/* evm.js -v 0.1.1 -build on 2016-11-17. 
 contact: yangty@evmtv.com */
(function(global, undefined) {

/*
 * ---------------------------0.1.1---------------------------------------------
 * ---------------------------2016-01-26----------------------------------------
 * 新增方法:
 * isUndefined 
 * cssText 一次修改元素样式
 * validator 表单验证
 * 修改方法
 * chunk: 可配置间隔时间
 * evm.stbInfo保存当前机顶盒厂商类别
 * ---------------------------2016-02-04----------------------------------------
 * 新增日志功能
 * ---------------------------2016-03-17----------------------------------------
 * 修改evm.text方法的判断语句
 * 增加evm.getElementsByClassName方法
 * -----------------------------------------------------------------------------
 * 修改evm.removeClass,删除任意两个class之间的class时, 结尾多删除空格
 * ---------------------------2016-03-29--------------------------------------------------
 * 修改手动导入键值表后,电脑端可能键盘不能正常操作的情况
 * -----------------------------------------------------------------------------
 */
 
// Avoid conflicting when `evm.js` is loaded multiple times
if (global.evm) {
    return;
}

/*
 * shim
 */

// 模拟ES5数组foreach方法
var _forEach = function() {
    if(![].forEach) {
        return function(items, fn) {
            if(_isString(items)) {
                items = items.split(' ');
            }
            for(var i = 0, len = items.length; i < len; i++) {
                fn(items[i], i);
            }
        };
    }
}();

// 判定宿主对象是否存在JSON对象
var _hasJSON = !!global.JSON;

/*
 * ape-base
 */

var _doc = document;

// 浏览器是否支持严格模式
var _hasStrictMode = function() {
   "use strict";
   return this === undefined;
}();

var _uniqueID = 1;


// 生成标示符,默认8位
function _guid (len) {
    len = len || 8;
    return (Math.random()+'').substr(-len);
};

// 生成随机数
var _rnd  = function(seed) {
    seed = ( seed * 9301 + 49297 ) % 233280;
    return seed / ( 233280.0 );
},
_rand = function (number) {
    var _seed = (new Date).getTime();
    return Math.ceil(_rnd(_seed) * number);
};


// 获取url传入的参数
var _getUrl = function () {
    var search=location.search?location.search.substr(1):'',
        args={},
        i=0,
        pieces=search?search.split('&'):[],
        item;
    
    if(pieces.length===0) return args;
    while(i<pieces.length) {
        item=pieces[i].split('=');
        args[item[0]] = decodeURIComponent(item[1]);
        i+=1;
    };
    return args;
};

// url后添加参数
var _createQuery = function(_u, _k, _v) {
    if(_u.indexOf('?') === -1) {
        _u += '?';
    }
    else{
        _u += '&';
    }
    _u += _k + '=' + encodeURIComponent(_v);
    return _u;
};

var _isType = function (type) {
    return function(obj) {
        return typeof obj === type;
    };
};

var _isObject = function(obj) {
    return typeof obj == 'object';
};

var _isFunction = function(obj) {
    return typeof obj == 'function';
};

var _isString = function(obj) {
    return typeof obj == 'string';
};

var _isBoolean = function(obj) {
    return typeof obj == 'boolean';
};

var _isNumber = function(obj) {
    return typeof obj == 'number';
};

var _isUndefined = function(obj) {
    return typeof obj == 'undefined';
};

// 去除字符串空格
var _trim = function (s){
    return s.replace(/^\s*|\s$/g, '');
};

var _extend = function (o) {
    //第一个参数是被赋值对象;可传多个对象给第一个对象赋值。
    var args = [],
        i = 1;
    
    if(arguments.length == 1) {
        args[i] = o;
        o = this;
    }else{
        args = arguments;
        o = arguments[0];
    }
    for(i; i < args.length; i++) {
        for(var m in args[i]) {
            o[m] = args[i][m];
        }
    }
    return o;
};

var _deepCopy = function (target, obj) {
    if(typeof obj === "undefiend") {
        obj = target;
        target = {};
    }
    for(var prop in obj) {
        var data = obj[prop];
        if(typeof  data !== "object") {
            target[prop] = obj[prop];
        }
        else{
            if(data instanceof Object) {
                if(data instanceof Array) {
                    target[prop] = [];
                    for(var i=0; i<data.length; i++) {
                        if(typeof data[i] !== "object") {
                            target[prop].push( data[i]);
                        }
                        else{
                            // Important! 跳过复制多维数组
                            target[prop][i] = _deepCopy({}, data[i]);
                        }
                    }
                }
                else{
                    target[prop] = _deepCopy({}, data);
                }
            }
            
        }
    }
    return target;
}

var _inherit = function (p) {
    if(p === null) throw TypeError();
    if(Object.create) return Object.create(p);
    if (!_isObject(p) && !_isFunction(p)) throw TypeError();
    function f(){};
    f.prototype = p;
    return new f;
};

var _merge = function (o, p) {
    for(var m in p) {
        if(!(o[m])) o[m] = p[m];
    }
    return o;
};

// 如果o中属性在p中没有,从o中删除该属性
var _restrict = function (o,p) {
    for(var m in o) {
        if(!(p[m])) delete o[m];
    }
    return o;
};

// 如果o中属性在p中存在,从o中删除该属性
var _subtract = function (o,p) {
    for(var m in o) {
        if(p[m]) delete o[m];
    }
    return o;
};

// 返回新对象同时拥有o,p的属性;如果o和p有重名属性,使用p的属性值
var _union = function (o,p) {
    return _extend(_extend({},o),p);
};

// 返回新对象,这个对象拥有同时在o和p中出现的属性
var _intersection = function (o,p) {
    return _restrict(_extend({},o),p);
};

var _throttle = function (fn, context) {
    clearTimeout(fn.tId);
    fn.tId = setTimeout(function(){
        fn.call(context);
    }, 100);
};

var _chunk = function (array, process, context, time) {
    var count = 0;
    time = _isNumber(time) ? time : 60;
    function fn() {
        process.call(context, array.shift(), count++);
        if(array.length > 0) setTimeout(fn, time);
    }
    fn();
};

var _arrayMatrix = function(numrows, numcols, initial) {
    var arr = [];
    for(var i=0; i<numrows; ++i) {
        var columns = [];
        for(var j=0; j<numcols; ++j) {
          columns[j] = initial;
        }
        arr[i] = columns;
    }
    return arr;
};

/*
 * ape-pub
 */

var _publisher = {
    subscribers: {any: []},
    on: function(type, fn, context) {
    var p = this;
    type = type || 'any';
    // fn可以是字符串,通过属性表达式
    fn = _isFunction(fn) ? fn : context[fn];
    p.subscribers[type] = p.subscribers[type] || [];
    p.subscribers[type].push({fn: fn, context: context});
    },
    off: function(type, fn, context) {
        this.visit('unsubscribe', type, fn, context);
    },
    emit: function(type, publication) {
        this.visit('publish', type, publication);
    },
    visit: function(action, type, args, context) {
        var pubtype = type || 'any',
            subscribers = this.subscribers[pubtype],
            max = subscribers ? subscribers.length : 0;
    
        for(var i = 0; i < max; i++) {
            if(action === 'publish') {
                subscribers[i].fn.call(subscribers[i].context, args);
            }else{
                if(subscribers[i].fn === args &&
                    subscribers[i].context === context) {
                    subscribers.splice(i,1);
                }
            }
        }
    }
};

var _makePublisher = function (o) {
    return _deepCopy(o, _publisher);
};

/*
 * ape-event
 */

// 绑定
var _on = function(target, type, handler, context) {
    target['on'+type] = function(e) {
        handler.call(context, e, this);
    };
};

// 解绑
var _off = function(target, type) {
    target['on'+type] = null;
};

// 只绑定一次
var _one = function(target, type, handler, context) {
    _on(target, type, function(e, target){
        handler.call(this,e, target);
        _off(target, type);
    }, context);
};

/*
 * ape-ajax
 */
var _str2json = function(_s) {
    var _json;
    if(!_isString(_s)) return false;
    if(_hasJSON) {
        try{
            _json = JSON.parse(_s);
        }
        catch(E) {
            _json = false;
        }
    }
    else{
        try{
            _json = eval("("+_s+")");
        }
        catch(E) {
            _json = false;
        }
    }
    return _json;
};

var _ajax = function() {
    var xhrId = 0,
    xhr = null,
    create = function() {
        if(window.XMLHttpRequest) {
            return function() {
                return new XMLHttpRequest();
            };
        }else{
            return function() {
                return new ActiveXObject('Msxml2.XMLHTTP');
            };
        }
    }(),
    Ajax = function(url, data, callback, abort, timeout, context) {
        var args = [],
        argsLen = arguments.length,
        xhr = null,
        evt = Ajax.evt;
      
        if(argsLen === 0) throw new Error('Not found parameters when invoking ajax');
        if(argsLen === 1) {
            //No1 situation：argument is an object like {url:'', data:'', callback:fn, abort:fn, timeout:fn} 
            args = arguments[0];
            if(typeof args == 'object') {
                if(!args.url)
                    throw new Error('*url* attribute is undefined');
                url = args.url;
                if(!args.callback)
                    throw new Error('*callback* attribute is undefined');
                callback = args.callback;
                data = args.data || null;
                abort = args.abort;
                timeout = args.timeout;
                context = args.context;
            }
        }else{
            //No2：many arguments
            if(context === undefined) {
                if(typeof timeout == 'object') {
                    context = timeout;
                    timeout = null;
                }else if(typeof abort == 'object') {
                    context = abort;
                    abort = null;
                }else if(typeof callback == 'object') {
                    context = callback;
                    callback = null;
                }
            }
            
            if(_isFunction(data)) {
                callback = data;
                data = null;
            }else{
                if(!_isFunction(callback))
                throw new TypeError();
            }
            
            if(!_isString(url))
                throw new TypeError();
        }
        xhr = create();
        xhr.guid = xhrId++; 
        xhr.open('GET', url, true); 
        xhr.onreadystatechange =  function() {
            if(xhr.readyState === 4 && 
            (xhr.status == 200 || xhr.status == 304)) {
                //callback.call(context || xhr, checkContent(xhr));
                callback.call(context || xhr, xhr.responseText);
                xhr.onreadystatechange = null;
                xhr = null;
            }
        };
        xhr.onabort = function() {
            xhr.onreadystatechange = null;
            (abort ? abort: callback).call(context || xhr, 'ABORT');
                xhr = null;
        };
        xhr.ontimeout = function() {
            xhr.onreadystatechange = null;
            (timeout ? timeout : callback).call(context || xhr, 'TIMEOUT');
                xhr = null;
        };
      
        //vt.push({guid: xhr.guid, xhr: xhr});
        xhr.send(data);
        return xhr;
    };
    
    function checkContent(r) {
        var contentType = r.getResponseHeader("Content-Type");
        
        if (!contentType) return r.responseText;
        //.json
        if(contentType.indexOf("json") !== -1 ) {
            return eval( 'false||' + r.responseText);
        }
        //.html .htm .xhtml .jsp
        if(contentType.indexOf("text/html") !== -1) {
            try{
                return eval( 'false||' + r.responseText);
            }catch(e){
                return r.responseText;
            }
        }
        //.xml .svg .vml .xsl
        if(contentType.indexOf("text/xml") !== -1 ) {
            return r.responseXML;
        }
        //.png
        if(contentType.indexOf("image/png") !== -1) {}
        if(contentType.indexOf("application/x-png") !== -1) {}
        //.jpg .jpeg .jpe
        if(contentType.indexOf("image/jpeg") !== -1) {}
        if(contentType.indexOf("application/x-jpg") !== -1) {}
        
        return r.responseText;
    }
    
    Ajax.evt = [];
    return Ajax;
}();
/*
 * ape-dom
 */

var _viaID = function (id) {
    if(_doc.getElementById)
        return _doc.getElementById(id);
    else
        return _doc.all(id);
};

var _viaTagName = function (name, root) {
    root = root || _doc;
    if(root.getElementsByTagName)
        return root.getElementsByTagName(name);
};

/*
 * shim method: 茁壮中间件不支持getElementsByClassName
 */
var _viaClassName = function (searchClass, node, tag){
    node = node || _doc;
    var nodes = node.getElementsByTagName(tag);
    var arrReturnElements = [];
    searchClass = searchClass.replace(/\-/g, '\\-');
    var pat = new RegExp("(^|\\s*)" + searchClass + "(\\s*|$)");
    for(var i=0; i < nodes.length; i++){
        node = nodes[i];
        if(pat.test(node.className)){
            arrReturnElements.push(node);
        }
    }
    return arrReturnElements;
};

var _getStyle = function (elem, prop) {
    if(elem.style[prop]) {
        return elem.style[prop];
    }else if(_doc.defaultView.getComputedStyle) {
        prop = prop.replace(/([A-Z])/g,"-$1");
        prop = prop.toLowerCase();
        return _doc.defaultView.getComputedStyle(elem, null)[prop];
    }else{
        return elem.currentStyle[prop];
    }   
};

var _cssText = function (elem, value) {
    if(_isString(value)) {
        if(elem.style.cssText.length == 1 && elem.style.cssText == 'C') {
            var style = value.split(';');
            for(var m=0; m<style.length; ++m) {
                var item = style[m].split(':');
                elem.style[item[0]] = item[1];
            }
        }
        else{
            if ( elem.style.cssText.length > 0 ) {
                elem.style.cssText = elem.style.cssText + value;
            }
            else {
                var style = value.split(';');
                for(var m=0; m<style.length; ++m) {
                    var item = style[m].split(':');
                    elem.style[item[0]] = item[1];
                }
            }
        }
        return true;
    }
};

var _css= function (elem, value){
    if(_isString(value)) {
        _cssText(elem, value);
    }else if(_isObject(value)){
        for(var m in value) elem.style[m] = value[m];
        return true;
    }
};


var _html = function (elem, value) {
    if(elem && !_isUndefined(value)){
        elem.innerHTML = value+'';
        return true;
    }
};

var _text = function (elem, value) {
    if(elem && !_isUndefined(value)) {
        if( _isString(elem.innerText) )
            elem.innerText = value+'';
        else if( _isString(elem.textContent) )
            elem.textContent = value+'';
        return true;
    }
};

var _createElem = function(type,conf,parent) {
  //evm.createElem( 'div', {id:'div2', style:'width:100px;height:50px;', attr:{exDragable:1}} );
    var o = _doc.createElement(type);
    // copy css
    for(var p in conf) {
        if(p === 'style') {
            _cssText(o, conf[p]);
        }else if(p === 'attr') {
            for( var i in conf[p] )
                o.setAttribute(i, conf[p][i] );
        }else{
            o[p] = conf[p];   
        }
    }

    if(_isUndefined(parent)) {
        _doc.body.appendChild(o);
    }else if(parent !== null){
        parent.appendChild(o);
    }
    return o;
};

var _removeElem = function(E) {
    if(E && E.parentNode && E.tagName.toLowerCase() !== 'body') {
        E.parentNode.removeChild(E);
        return true;
    }
};

var _toggleDisplay = function(_e,_d) {
    // 块级元素:display切换[block,none]
    if(_isString(_d)) {
        var val = (_d === 'show' ? 'block' : 'none');
        _css(_e, {display:val});
        return true;
    }
};
/*
 * evm is a function.
 */
var evm = global.evm = function (selector, root, tag) {
    if(!this === global) return arguments.callee(selector, root, tag);
  
    if(!_isString(selector)) return evm;
  
    switch(selector.charAt(0)) {
    case '#':
        evm.queryData = _viaID(selector.substr(1));
        break;
    case '.':
        if(!root && !tag) {
            evm.queryData = _viaClassName(selector.substr(1), _doc, '*');
        }else{
            evm.queryData = _viaClassName(selector.substr(1), root||_doc, tag||'*');
        }
        break;
    default:
        if(!root) {
            evm.queryData = _viaTagName(selector, _doc);
        }else{
            evm.queryData = _viaTagName(selector, root);
        }
    }
    return evm.queryData;
};

// 判定浏览器厂商信息，允许在外部修改
var _ua = navigator.userAgent.toLowerCase();
var _stb = false;
var _platform = null;
var _browser = null;
var _stbRegExp = [];
var _hasStbRegExp = false;
var _stbRegExpIscompleted = false;

if(/dvnbrowser/.test(_ua)) {
	_stb = 'DVN';
    _platform = 'dvn';
    _browser = 'stb';
}
else if(/ipanel/.test(_ua)) {
    _stb = 'iPanel';
    _platform = 'ipanel';
    _browser = 'stb';
}
else if(/evm/.test(_ua) || /enrich/.test(_ua)) {
    _stb = 'Enrich';
    _platform = 'enrich';
    _browser = 'stb';
}
else if(/wobox/.test(_ua) || /inspur/.test(_ua) || /set-top box/.test(_ua)) {
    _stb = 'Inspur';
    _platform = 'inspur';
    _browser = 'stb';
}
else if(/coship/.test(_ua)) {
    _stb = 'Coship';
    _platform = 'coship';
    _browser = 'stb';
}
else if(window.ActiveXObject) {
    _browser = 'pc';
    _platform = 'ie';
}
else if(document.getBoxObjectFor || /firefox/.test(_ua)) {
    _browser = 'pc';
    _platform = 'firefox';
}
else if(window.MessageEvent && !document.getBoxObjectFor) {
    _browser = 'pc';
    _platform = 'chrome';
}


evm.stbInfo = {
    stb: _stb,
    browser: _browser,
    platform: _platform
}

var _getStbBrowser = function () {
    return evm.stbInfo;
};

evm.addStbUAExpression = function( obj ) {
    // { expression : //, stb : '', platform : '', browser : '' }
    if ( !obj.expression || !obj.stb || !obj.browser ) return false;
    _stbRegExp.push( obj );
    if ( !_hasStbRegExp ) _hasStbRegExp = true;
    return _stbRegExp;
};

// 手动设置中间件
evm.setStbInfo = function(_name) {
    if(!evm.isString(_name))
        throw new Error('the param type must be string');
    // 赋值
    evm.stbInfo.stb = _name;
    evm.stbInfo.platform = _name;
    return evm.stbInfo;
};

// 导入中间件名称和键值
evm.importKeyCode = function(_config) {
    if(!evm.isObject(_config))
        throw new Error('the param is not an object');
    if(!util_keymap)
        throw new Error('not import util-keymap.js');
    if(!_config.stb || !_config.keymap)
        throw new Error('not found stb or keymap property in object config');
    
    util_keymap[_config.stb] = _config.keymap;
};

// 通用命名空间方法
evm.namespace=function(ns_str) {
    var parts=ns_str.split('.'), parent=evm,i;
    // 剥离最前面的全局变量
    if(parts[0]==="evm") {
        parts=parts.slice(1);
    }
    for(i=0;i<parts.length;i+=1) {
        // 如果它不存在,就创建属性
        if(_isUndefined(parent[parts[i]])) {
            parent[parts[i]]={};
        }
        parent=parent[parts[i]];
    }
    return parent;
};

evm.namespace("evm.data");
evm.namespace("evm.cache");
evm.namespace("evm.ext");

/*
 * ape-cls
 */

var _hasClass, _addClass, _removeClass, _toggleClass;

var _hasClassList = function(){
    return !!_doc.documentElement.classList || false;
}();

if(!_hasClassList) {
    _hasClass = function(elem, clsName) {
        return new RegExp('(^|(\\s)*)' + clsName + '((\\s)*|$)').test(elem.className);
    };
    _addClass = function(elem, clsName) {
        if(!_hasClass(elem, clsName))
            elem.className += (elem.className ? ' ' : '') + clsName;
    };
    _removeClass = function(elem, clsName) {
        if (_hasClass(elem, clsName))
            elem.className = elem.className.replace(new RegExp('(^|(\\s)*)' + clsName, 'g'), '');
    };
    _toggleClass = function(elem, clsName) {
        (_hasClass(elem, clsName) ? _removeClass : _addClass)(elem, clsName);
    };
}else{
    _hasClass = function(elem, clsName) {
        return elem.classList.contains(clsName);
    };
    _addClass = function(elem, clsName) {
        elem.classList.add(clsName);
    };
    _removeClass = function(elem, clsName) {
        elem.classList.remove(clsName);
    };
    _toggleClass = function(elem, clsName) {
        elem.classList.toggle(clsName);
    };
}

/*
 * ape-cookie
 */

var _cookie;
var _cutCookie;
(function() {
  var pluses = /\+/g;
  
  function encode(s) {
    return config.raw ? s : encodeURIComponent(s);
  }

  function decode(s) {
    return config.raw ? s : decodeURIComponent(s);
  }

  function stringifyCookieValue(value) {
    return encode(config.json ? JSON.stringify(value) : String(value));
  }

  function parseCookieValue(s) {
    if (s.indexOf('"') === 0) {
      // a quoted cookie as according to RFC2068, unescape...
      s = s.slice(1, -1).replace(/\\"/g, '"').replace(/\\\\/g, '\\');
    }

    try {
      // If can't decode the cookie, ignore it
      // If can't parse the cookie, ignore it
      s = decodeURIComponent(s.replace(pluses, ' '));
      return config.json ? JSON.parse(s) : s;
    } catch(e) {}
  }

  function read(s, converter) {
    var value = config.raw ? s : parseCookieValue(s);
    return _isFunction(converter) ? converter(value) : value;
  }
  
  var config = _cookie = function (key, value, options) {
  // Write
  if(value !== undefined && !_isFunction(value)) {
    options = _extend({}, config.defaults, options);
    
    if (typeof options.expires == 'number') {
     var days = options.expires,
       t = options.expires = new Date();
     t.setTime(+t + days * 864e+5);
    }
 
    return (document.cookie = [
     encode(key), '=', stringifyCookieValue(value),
     options.expires ? '; expires=' + options.expires.toUTCString() : ''
     //,
     // use expires attribute, max-age is not supported by IE
     //options.path    ? '; path=' + options.path : '',
     //options.domain  ? '; domain=' + options.domain : '',
     //options.secure  ? '; secure' : ''
    ].join(''));
  }

  // Read
  var result = key ? undefined : {};

  // To prevent the for loop in the first place assign an empty array
  // in case there are no cookies at all. Also prevents odd result when
  // calling cookie().
  var cookies = document.cookie ? document.cookie.split('; ') : [];
  
  for (var i = 0, l = cookies.length; i < l; i++) {
    var parts = cookies[i].split('=');
    var name = decode(parts.shift());
    var cookie = parts.join('=');
    if (key && key === name) {
     //if second parameter is a function it's a converter...
     result = read(cookie, value);
     break;
    }
 
    // Prevent storing a cookie that couldn't decode.
    if (!key && (cookie = read(cookie)) !== undefined) {
     result[name] = cookie;
    }
  }

  return result;
  };

  config.defaults = {
    raw: false,
    json: false
  };

  _cutCookie = function (key, options) {
    if (_cookie(key) === undefined) {
     return false;
    }
    _cookie(key, '', _extend({}, { expires: -1 }));
    return !_cookie(key);
  };
  return _cookie;
})();

/*
 * ape-controller
 */

function _controller(evt) {
    evt = evt || window.event;
    var key = evt.which || evt.keyCode,
        items = _controller.items,
        isBlock = (_controller.isBlock = 0),
        i = 0,
        alias = null,
        target = null,
        result;
    
    if ( _hasStbRegExp && !_stbRegExpIscompleted ) {
        _stbRegExpIscompleted = true;
        for (; i < _stbRegExp.length; ++i ) {
            if ( _stbRegExp[ i ].expression.test( _ua ) ) {
                evm.stbInfo.stb = _stbRegExp[ i ].stb;
                evm.stbInfo.browser = _stbRegExp[ i ].browser;
                evm.stbInfo.platform = _stbRegExp[ i ].platform || _stbRegExp[ i ].stb;
            }
        }
    }
    
    if ( evm.stbInfo.browser === 'stb' ) {
        // 已判断到中间件类型
    }
    else {
        if ( _isString( evm.stbInfo.stb ) && ( evm.stbInfo.browser === 'pc' ) ) {
            // 手动设置并且browser是pc,优先用pc的键值
            evm.stbInfo.platform = 'pc';
        }
        if ( _isBoolean( evm.stbInfo.stb ) ) {
            // 未手动设置,用pc键值
            evm.stbInfo.platform = 'pc';
        }
    }
    
    if(util_keymap[ evm.stbInfo.platform ][key]) {
        alias = util_keymap[ evm.stbInfo.platform ][key];
    }else if(util_keymap[key]) {
        alias = util_keymap[key];
    }
    
    if(evm.onLogKeyEvent) {
        evm.onLogKeyEvent({
            type: 'onLogKeyEvent',
            keyCode: key,
            alias: alias,
            keymap: util_keymap,
            target: evm
        });
    }
    
    if(logPanelIsListening) {
        // 阻止后面的事件分发
        return _controller.halt(isBlock, evt);
    }
    
    if(items.length === 0) {
        // 监听对象为空
        return _controller.halt(isBlock, evt);
    }
    
    if(typeof util_keymap === "undefined") {
        // 未引入util_keymap文件
        throw Error("Pls import util_keymap.js!");
    }
    
    // 取数组最后一项view
    target = items[items.length - 1];
    
    // 判断view是否有onPublicEvent函数
    if(evm.isFunction(target.context.onPublicEvent)) {
        result = target.context.onPublicEvent({
            type: 'onPublicEvent',
            keyCode: key,
            alias: alias,
            keymap: util_keymap,
            target: target.context
        });
        if(result === 1) {
            return _controller.halt(result, evt);
        }
    }
    
    // 判断view是否有onEvent函数
    if(evm.isFunction(target.context.onEvent)) {
        result = target.context.onEvent({
            type : 'onEvent',
            keyCode : key,
            alias : alias,
            keymap : util_keymap,
            target : target.context
        });
    }
    
    if(result === 1) {
        return _controller.halt(result, evt);
    }else{
        // 判断view是否有grabEvent函数
        if(typeof target.fn === 'function') {
            result = target.fn.call(target.context, key, {
                keyCode: key,
                alias: alias,
                keymap: util_keymap,
                target: target.context
            });
        }
    }
  
    return _controller.halt(result === 1 ? result : isBlock, evt);
}

_controller.halt = function(_isBlock, _evt) {
    if(_isBlock === 1 && _evt) {
        if(_evt.preventDefault) _evt.preventDefault();
        return 0;
    }
    return 1;
}

_controller.isBlock = 0;
_controller.items = [];

//pub-sub mode
_controller.subscribe = function(item) {
    if(item === null || item === undefined) throw typeError();
    if(typeof item != 'object') throw typeError();
  
    var self = this,
        i = 0,target,callback,context,method;
  
    if(item.context === undefined) 
        throw new Error('Not fount *context* property');
    if(item.method === undefined) 
        throw new Error('Not fount *method* property');
    
    context = item.context;
    callback = item.callback;
    method = item.method;
  
    //check up the type of callback
    callback = (typeof callback == 'string') ? context[callback] : callback;
  
    if(method == 'add') {
        self.items.push({fn: callback, context: context});
    }else if(method == 'remove') {
        do{
            target = self.items[i];
            if(target.fn === callback && target.context === context){
                self.items.splice(i, 1); 
                break;
            }
        }while(self.items[++i]);
    }
    
    return self;
};

/*
 * ape-component
 */

evm.namespace('evm.ext.comp');
// 组件的基类
evm.ext.comp.BaseComponent = function(_c) {
    var _prefix      = _c && _c.prefix || 'Ape',
        _comp_name   = _c && _c.compName || 'Component';
    
    this.host_obj    = window;
    this.parent_comp = _c && _c.parentComp || null;
    this.comp_uid    = evm.uniqueID + '';
    this.comp_name   = _prefix + _comp_name + '_' + evm.uniqueID++;
    this.class_name  = _prefix +_comp_name;
    _makePublisher(this);
}

/*
 * ape-ModuleController
 */

function ModuleController(_c) {
    this.module_array = []; // 模块数组
    this.active_index = -1; // 索引
    this.module_count = 0;  // 计数器
    this.back_module = null; // 之前的模块
    this.active_module = null; // 当前的模块
    this.constr_name = 'ModuleController';
    this.inst_name = 'MoudleController_inst_' + ModuleController.count++;
    if(evm.isUndefined(_c.onFocus) || !evm.isFunction(_c.onFocus)) {
        throw Error('onFocus not define');
    }
    if(evm.isUndefined(_c.onBlur) || !evm.isFunction(_c.onBlur)) {
        throw Error('onBlur not define');
    }
    if(evm.isUndefined(_c.onChange) || !evm.isFunction(_c.onChange)) {
        throw Error('onChange not define');
    }
    if(evm.isUndefined(_c.onChangeOut) || !evm.isFunction(_c.onChangeOut)) {
        throw Error('onChangeOut not define');
    }
  
    this.config = _c;
    // 历史原因,兼容部分老页面
    if(_isFunction(_c.grabEvent)) {
        this.grabEvent = _c.grabEvent;
    }
    this.onBlur = _c.onBlur;
    this.onFocus = _c.onFocus;
    this.onChange = _c.onChange;
    this.onChangeOut = _c.onChangeOut;
    this.onPublicEvent = _c.onPublicEvent || null;
    //this.onKeyEvent = _c.onKeyEvent || null;
};
ModuleController.count = 0;
_extend(ModuleController.prototype, {
    init: function() {
        var me = this;
        if(me.module_array.length > 0) {
            me.setActiveIndex(0);
            me.onFocus({
                type: "init"
                ,module: me.active_module
            });
        }
        return me;
    },
    onEvent: function(_e) {
        // 事件总入口
        var me = this
        ,isBlock = 0
        ,moduleInst = me.module_array[me.active_index].inst;
        if(evm.isFunction(moduleInst.action)) {
            isBlock = moduleInst.action(_e.alias, _e);
        }
        return isBlock;
    },
    setActiveIndex: function(_n) {
        var me = this;
        me.active_index = _n;
        if(me.back_module !== me.active_module) {
            me.back_module = me.active_module;
        }
        me.active_module = me.module_array[me.active_index];
        me.onChange({
            type: "setActiveIndex"
            ,activeModule: me.active_module
            ,backModule: me.back_module
        });
        return this;
    },
    addListener: function() {
        var me = this;
        evm.controller.subscribe({
            method   : 'add',
            callback : me.grabEvent || null,
            context  : me
        });
        me.onFocus({type:'addListener'});
        return me;
    },
    removeListener: function() {
        var me = this;
        evm.controller.subscribe({
            method   : 'remove',
            callback : me.grabEvent || null,
            context  : me
        });
        me.onBlur({type:'removeListener'});
        return me;
    },
    addModule: function(_c) {
        var me = this;
        if(evm.isUndefined(_c)) {
            throw Error('not find config object');
        }
        if(!evm.isFunction(_c.constr)) {
            throw Error('not find constructor');
        }
        var _inst = _c.constr();
        var newModule = {
            instNo: (me.module_count++)
            ,moduleName:_c.moduleName
            ,inst: _inst
            ,parent_inst: me
            ,map:_c.map
        };
        me.module_array.push(newModule);
        me.onChange({
            type: 'addModule'
            ,module: newModule
        });
        return me;
    },
    getModuleInstance: function(_s) {
        // 获取模块的实例: 传入模块名称
        var me = this
        ,_instance = null;
        if(evm.isString(_s)) {
            for(var i=0; i<me.module_count; i+=1) {
                if(me.module_array[i].moduleName === _s) {
                    _instance = me.module_array[i].inst;
                    break;
                }
            }
        }
        return _instance;
    },
    getModule: function(_s) {
        // 切换当前模块: 传入模块名称,模块索引或缺省参数三种方式
        var me = this;
        if(evm.isString(_s)) {
            for(var i=0; i<me.module_count; i+=1) {
                if(me.module_array[i].moduleName === _s) {
                    if(me.back_module !== me.active_module) {
                        me.back_module = me.active_module;
                    }
                    me.active_module = me.module_array[i];
                    me.active_index = i;
                    me.onChange({
                        type: 'getModuleViaName'
                        ,activeModule: me.active_module
                        ,backModule: me.back_module
                    });
                    break;
                }
            }
        }else if(evm.isNumber(_s)) {
            if(me.module_array[_s]) {
                if(me.back_module !== me.active_module) {
                    me.back_module = me.active_module;
                }
                me.active_module = me.module_array[_s];
                me.active_index = _s;
            }else{
                me.active_module = null;
            }
            me.onChange({
                type: 'getModuleViaIndex'
                ,activeModule: me.active_module
                ,backModule: me.back_module
            });
        }else{
            if(me.module_array[me.active_index]) {
                if(me.back_module !== me.active_module) {
                    me.back_module = me.active_module;
                }
                me.active_module = me.module_array[me.active_index];
            }else{
                me.active_module = null;
            }
      
            me.onChange({
                type: 'getModuleByDefault'
                ,target: me.active_module
                ,backModule: me.back_module
            });
        }
        return me.active_module;
    }
});

/*
 * ape-formValidator v0.1.0
 */

var _Validator = (function() {
 
var validator = {
  //调试开关
  debug: false,
  //所有可用的检查
  types: {},
  //在当前验证会话中的错误消息
  messages: [],
  //当前验证配置
  //名称: 验证类型
  config: {},
  //接口方法
  //'data' 键值对
  validate: function(data) {
    var i, j, msg, type, checker, checker_type, result_ok;
    
    //重置所有消息
    this.messages = [];
    
    for(i in data) {
      type = this.config[i];
      
      if(!type) {
        continue; //不需要验证
      }
      
      if(typeof type == 'string') {
        //一个验证
        checker_type = 'one';
        checker = this.types[type]; 
      }else{
        //多个验证
        checker_type = 'mulitple';
        checker = [];
        for(j = 0; j < type.length; j++) {
          checker[j] = this.types[type[j]];
        }
      }
      
      if(!checker) {
        throw {
          name: 'ValidationError',
          message: 'not found validation method'
        };
      }
      
      if(checker_type == 'one') {
          result_ok = checker.validate(data[i]);
          if(!result_ok) {
            msg = ((validator.debug ?( '错误的值 *' + i + '* ,') : '') ) +
              checker.instructions;
            //msg = 'Invalid value for' + ((validator.debug ?( ' *' + i + '* ') : '') ) + ' ,' + checker.instructions;
            this.messages.push({msg: msg, id: i});
          }
        }else if(checker_type == 'mulitple'){
        for(j = 0; j < checker.length; j++) {
            result_ok = checker[j].validate(data[i]);
            if(!result_ok) {
              msg = ((validator.debug ? ('错误的值 *' + i + '* ,') : '')) +
                checker[j].instructions;
              //msg = 'Invalid value for' + ((validator.debug ? (' *' + i + '* ') : '')) + ' ,' + checker[j].instructions;
              this.messages.push({msg: msg, id: i});
              break;
            }
          }
      }
      
    }
    return this.hasErrors();
  },
  hasErrors: function() {
    return this.messages.length;
  }
  };

  //======== 身份证相关代码开始 ========
  var Wi = [ 7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2, 1 ];
  var ValideCode = [ 1, 0, 10, 9, 8, 7, 6, 5, 4, 3, 2 ];
  
  //去掉字符串头尾空格
  function trim(str) {   
    return str.replace(/(^\s*)|(\s*$)/g, "");   
  }
  
  /*
   * 判断身份证号码为18位时最后的验证位是否正确  
   * param a_idCard 身份证号码数组  
   */
  function isTrueValidateCodeBy18IdCard(a_idCard) {
    var sum = 0; 
    if(a_idCard[17].toLowerCase() == 'x') {
      a_idCard[17] = 10; 
    }
    for(var i = 0; i < 17; i++) {
      sum += Wi[i] * a_idCard[i];
    }   
    valCodePosition = sum % 11; 
    if(a_idCard[17] == ValideCode[valCodePosition]) {
      return true;
    }else{
      return false;
    }
  }
  /* 
   * 通过身份证判断是男是女  
   * idCard 15/18位身份证号码   
   * return 'female'-女、'male'-男  
   */  
  function maleOrFemalByIdCard(idCard){
    idCard = trim(idCard.replace(/ /g, ""));
    if(idCard.length==15){
        if(idCard.substring(14,15)%2==0){
          return 'female';
        }else{
          return 'male';
        }
    }else if(idCard.length ==18){
      if(idCard.substring(14,17)%2==0){
        return 'female';
      }else{
        return 'male';
      }
    }else{
      return null;
    }
  }   
   /*
    * 验证18位数身份证号码中的生日是否是有效生日
    * param idCard 18位书身份证字符串
    */  
  function isValidityBrithBy18IdCard(idCard18){
    var year =  idCard18.substring(6,10);
    var month = idCard18.substring(10,12);
    var day = idCard18.substring(12,14);
    var temp_date = new Date(year,parseFloat(month)-1,parseFloat(day));
    if(temp_date.getFullYear()!=parseFloat(year)
          ||temp_date.getMonth()!=parseFloat(month)-1
          ||temp_date.getDate()!=parseFloat(day)){
      return false;
    }else{
      return true;
    }
  }
  /*
   * 验证15位数身份证号码中的生日是否是有效生日
   * param idCard15 15位书身份证字符串
   */  
  function isValidityBrithBy15IdCard(idCard15){
    var year =  idCard15.substring(6,8);
    var month = idCard15.substring(8,10);
    var day = idCard15.substring(10,12);
    var temp_date = new Date(year,parseFloat(month)-1,parseFloat(day));
    if(temp_date.getYear()!=parseFloat(year)
     ||temp_date.getMonth()!=parseFloat(month)-1
     ||temp_date.getDate()!=parseFloat(day)){
     return false;
     }else{
      return true;
     }
  }
  
  function IdCardValidate(idCard) {
    idCard = trim(idCard.replace(/ /g, ""));
    if(idCard.length == 15) {
      return isValidityBrithBy15IdCard(idCard);
    }else if(idCard.length == 18) {
      var a_idCard = idCard.split("");
      if(isValidityBrithBy18IdCard(idCard)&&isTrueValidateCodeBy18IdCard(a_idCard)){
        return true;
      }else{
        return false;
      }
    }else{
      return false;
    }
  }
  //======== 身份证相关代码结束 ========
  
  //======== 手机号码相关代码开始 ========
  //正则查询手机号码
  var RegCellPhone = /^([0-9]{11})?$/;
  function isMobile(mob) {
    if(mob.length ==0) return false;
    return RegCellPhone.test(mob);
  }
  //======== 手机号码相关代码结束 ========
  
  //======== 以下是各公共表单字段的验证方法========
  
  //严格检查身份证号是否正确
  validator.types.isCardNo = {
    validate: function(value) {
      return IdCardValidate(value);
    },
    instructions: '号码不正确'
  };
  
  //检查手机号码
  validator.types.isMobile = {
    validate: function(value) {
      return isMobile(value);
    },
    instructions: '号码不正确'
  };
  
  //检查非空值
  validator.types.isNonEmpty = {
    validate: function(value) {
      return value != '';
    },
    instructions: '为空'
    //instructions: 'the value cannot be empty'
  };

  //检查是否是一个数字
  validator.types.isNumber = {
    validate: function(value) {
      return !isNaN(value);
    },
    instructions: '只能包含数字'
    //instructions: 'the value can only be a valid number, e.g. 1, 3.14 or 2014'
  };
  
  //检查是否只包含字母和数字
  validator.types.isAlphaNum = {
    validate: function(value) {
      return !/[^a-z0-9]/i.test(value);
    },
    instructions: '只能包含字母和数字'
    //instructions: 'the value can only contain characters and numbers, no special symbols'
  };
  
return validator;
})();

/*
 * 日志工具
 * 须绑定evm.controller方法
 */

// 日志开关,默认开启
evm.logSwitch = true;
// 日志面板是否可见
evm.logPanelIsVisible = false;
// 预设的显示或隐藏组合键
var logKeyArray = ["1", "5", "9"];
// 预设的增加按键监听组合键
var logListenerArray = ["9", "5", "1"];
// 接收的按键队列
var receiveArray = [];
// 按键计时器
var logKeyTimer = -1;
// 延迟计算scroll高度计时器
var scrollHeightTimer = -1;
// 设置scroll高度延迟
var scrollDelay = 400;
// 按键间隔时长
var logKeyDelay = 2000;
// 日志面板元素引用
var logPanelElem = null;
// 日志滚动元素引用
var logScrollElem = null;
// 日志面板监听监听按键
var logPanelIsListening = false;

function delayEraseReceiveArray(_time) {
    logKeyTimer = setTimeout(function() {
        receiveArray.length = 0;
    }, _time || logKeyDelay);
}

// 初始化
evm.initLog = function(_config) {
    // _config配置日志面板的属性
    var me = evm,
        panelStyle = 'position:absolute;overflow:hidden;background:#000;display:none;filter: alpha(opacity=70);opacity:0.7;word-wrap:break-word;',
        scrollStyle = 'position:absolute;top:0px;width:100%',
        fontSize = '14px',
        width = '440px',
        height = '600px',
        left = '40px',
        top = '40px';
    
    if(!_isObject(_config)) {
        // 默认属性
        panelStyle += 'width:'+width+';height:'+height+';top:'+top+';left:'+left+';font-size:'+fontSize;
    }
    else{
        for(var p in _config) {
            panelStyle += p + ':' + _config[p] + ';';
        }
        
        if(!_config.width) {
            panelStyle += 'width:'+width+';';
        }
        if(!_config.height) {
            panelStyle += 'height:'+height+';';
        }
        if(!_config.left) {
            panelStyle += 'left:'+left+';';
        }
        if(!_config.top) {
            panelStyle += 'top:'+top+';';
        }
        if(!_config.fontSize) {
            panelStyle += 'font-size:'+fontSize+';';
        }
    }
    
    if(!document.body) {
        throw Error('document.body not found');
    }
    
    if(!logPanelElem) {
        logPanelElem = _createElem('div', {
            id: 'evmtvLogPanel',
            style: panelStyle
        }, document.body);
    }
    
    if(!logScrollElem) {
        logScrollElem = _createElem('div',{
            id: 'evmtvLogScroll',
            style: scrollStyle
        },logPanelElem)
    }
};

// 增加日志
evm.log = function(_value) {
    if(!logScrollElem) evm.initLog();
    var me = evm,
        prefix = '<br/>&nbsp;[evmjsLog]&nbsp;&nbsp;',
        node = _createElem('p', {
            style: 'color:#FFF'
        }, null);
        node.innerHTML = prefix +_value;
    logScrollElem.appendChild(node);
    
    setScrollTop();
};

// 设置日志可视区域位置
function setScrollTop(_time) {
    scrollHeightTimer = setTimeout(function() {
        var scrollTop = parseInt(logScrollElem.style.top),
            scrollHeight = parseInt(logScrollElem.scrollHeight),
            panelHeight = parseInt(logPanelElem.style.height);
        
        if(scrollHeight <= panelHeight)
            return false;
        
        scrollTop = panelHeight - scrollHeight;
        
        logScrollElem.style.top = scrollTop + 'px';
        
    }, _time || scrollDelay);
}

// 清空日志
evm.eraseLog = function() {
    var me = evm;
    _css(logScrollElem, {top:'0px'});
    _html(logScrollElem, '');
};

// 日志翻页
evm.thumbLog = function(_dir, _offset) {
    var me = evm;
    var scrollTop = parseInt(logScrollElem.style.top),
            scrollHeight = parseInt(logScrollElem.scrollHeight),
            panelHeight = parseInt(logPanelElem.style.height);
    
    _offset = _offset || 60;
    
    if(_dir == 'UP') {
        if((scrollTop + _offset) <= 0) {
            scrollTop += _offset;
        }
        else {
            scrollTop = 0;
        }
        logScrollElem.style.top = scrollTop + 'px';
    }
    else if(_dir == 'DOWN') {
        if((scrollHeight - panelHeight > 0)) {
            if((scrollTop + _offset * -1) > (panelHeight - scrollHeight)) {
                scrollTop += _offset * -1;
            }
            else{
                scrollTop = panelHeight - scrollHeight;
            }
            logScrollElem.style.top = scrollTop + 'px';
        }
    }
};

// 设置日志面板位置
evm.logPanelMoveTo = function(_x, _y) {
    var me = evm;
    if(_isNumber(_x)) logPanelElem.style.left = _x + 'px';
    if(_isNumber(_y)) logPanelElem.style.top = _y + 'px';
};

// 隐藏日志面板
evm.hideLogPanel = function() {
    logPanelElem.style.display = 'none';
    me.logPanelIsVisible = false;
};

// 日志的监听事件
evm.onLogKeyEvent = function(_event) {
    var me = evm,
        i = 0,
        count = 0,
        alias = _event.alias,
        keyCode = _event.keyCode,
        code = '';
    
    clearTimeout(logKeyTimer);
    clearTimeout(scrollHeightTimer);
    
    if(!me.logSwitch) return false;
    
    if(48 <= keyCode && keyCode <= 57) {
        alias = (keyCode - 48)+'';
    }
    
    // 存入接收到的键值
    if(alias) {
        receiveArray.push(alias);
    }
    
    if(logPanelIsListening) {
        switch(alias) {
            case '2':
            case 'UP':
                evm.thumbLog('UP');
                break;
            case '8':
            case 'DOWN':
                evm.thumbLog('DOWN');
                break;
            case '9':
                logPanelIsListening = false;
                break;
            case '0':
                //evm.eraseLog();
                break;
        }
    }
    
    if(receiveArray.length < logKeyArray.length) {
        delayEraseReceiveArray();
        return false;
    }
    
    // 判断当前接收的键值与预设的是否相等
    for(; i<logKeyArray.length; ++i) {
        if(logKeyArray[i] == receiveArray[i])
            count++;
        else
            break;
    }
    
    if(count != logKeyArray.length) {
        code = 'error';
    }
    else{
        code = 'success';
    }
    
    if(code == 'success') {
        me.logPanelIsVisible = !me.logPanelIsVisible;
        if(!logPanelElem) {
            evm.initLog();
        }
        logPanelElem.style.display = me.logPanelIsVisible?'block':'none';
        receiveArray.length = 0;
    }
    else if(code == 'error') {
        count = 0;
        for(i=0; i<logListenerArray.length; i++) {
            if(logListenerArray[i] == receiveArray[i])
                count++;
            else
                break;
        }
        if(count !== logListenerArray.length) {
            code = 'error';
        }
        else {
            code = 'success';
            if(me.logPanelIsVisible) {
                logPanelIsListening = true;
            }
        }
        
        receiveArray.length = 0;
    }
    return code;
};


evm.version = '0.1.1';
// The charset for requesting files
evm.charset = "utf-8";

// Public API:

evm.hasClass = function(elem, clsName) {
    return _hasClass(elem, clsName);
};

evm.addClass = function(elem, classes) {
    if(_isString(classes)){
        _addClass(elem, classes);
    }else{
        _forEach ? _forEach(classes, function(cls) { _addClass(elem, cls); }) :
        classes.forEach(function(cls) { _addClass(elem, cls); });
    }
};

evm.removeClass = function(elem, classes) {
    if(_isString(classes)) {
        _removeClass(elem, classes);
    }else{
        _forEach ? _forEach(classes, function(cls) { _removeClass(elem, cls); }) :
        classes.forEach(function(cls) { _removeClass(elem, cls); });
    }
};

evm.toggleClass = function(elem, classes) {
    if(_isString(classes)) {
        _toggleClass(elem, classes);
    }else{
        _forEach ? _forEach(classes, function(cls) { _toggleClass(elem, cls); }) :
        classes.forEach(function(cls){ _toggleClass(elem, cls); })
    }
};

evm.$ = function(selector) {
    return evm('#' + selector);
};
evm.className = function(selector, root, tag) {
    return evm('.' + selector, root, tag);
};
evm.tag = function(tag, root) {
    return evm(tag, root);
};

if ( !evm.post ) {
    evm.post = function( url, param, callback, context ) {
        var xhr = null;
        if ( window.XMLHttpRequest )
            xhr = new XMLHttpRequest();
        else
            xhr = new ActiveXObject('Msxml2.XMLHTTP');
        
        xhr.open( 'POST', url, true );
        xhr.setRequestHeader("Content-type","application/x-www-form-urlencoded");
        xhr.onreadystatechange =  function() {
            if(xhr.readyState === 4 && 
            (xhr.status == 200 || xhr.status == 304)) {
                if ( "function" == typeof callback ) {
                    callback.call(context || xhr, xhr.responseText);
                    xhr.onreadystatechange = null;
                }
                
            }
        };
        if ( !param ) param = null;
        xhr.send( param );
        
    };
}

evm.ajax = _ajax;
evm.arrayMatrix = _arrayMatrix;
evm.chunk = _chunk;
evm.controller = _controller;
evm.cookie = _cookie;
evm.createQuery = _createQuery;
evm.css = _css;
evm.cssText = _cssText;
evm.createElem = _createElem;
evm.cutCookie = _cutCookie;
evm.deepCopy = _deepCopy;
evm.extend = _extend;
evm.forEach = _forEach;
evm.getElementsByClassName = _viaClassName;
evm.getStbBrowser = _getStbBrowser;
evm.getStyle = _getStyle;
evm.getUrl = _getUrl;
evm.guid = _guid;
evm.hasJSON = _hasJSON;
evm.html = _html;
evm.inherit = _inherit;
evm.intersection = _intersection;
evm.isBoolean = _isBoolean;
evm.isFunction = _isFunction;
evm.isNumber = _isNumber;
evm.isUndefined = _isUndefined;
evm.isObject = _isObject;
evm.isString = _isString;
evm.makePublisher = _makePublisher;
evm.ModuleController = ModuleController;
evm.merge = _merge;
evm.on = _on;
evm.off = _off;
evm.one = _one;
evm.rand = _rand;
evm.removeElem = _removeElem;
evm.restrict = _restrict;
evm.str2json = _str2json;
evm.subtract = _subtract;
evm.text = _text;
evm.toggleDisplay = _toggleDisplay;
evm.trim = _trim;
evm.throttle = _throttle;
evm.uniqueID = _uniqueID;
evm.union = _union;
evm.validator = _Validator;

})(this);
 /* Thank you for using evm.js. */