/*
 * 组件
 */

// 网格
evm.ext.comp.Grid = function(_c/*config object*/) {
    // 强制使用new
    if(this === evm.ext.comp || this === window)
        return new arguments.callee(_c);
    
    // 必须传参
    if(evm.isUndefined(_c) && !(evm.isObject(_c)))
        throw Error('Grid constructor not found config parameter');
    
    function hander(_c/*event object*/){
        // 触发事件的默认方法
        try{
            //console.log('Grid 事件触发,默认处理方法');
        }catch(E){}
    }
  
    evm.ext.comp.BaseComponent.call(this, _c/*object*/);
    this.config          = _c; // 配置项
    this.box_width       = 0; // 容器宽
    this.box_height      = 0; // 容器高
    this.box_elem        = null; // 容器
    this.box_id          = _c.boxID || this.comp_name;
    this.grid_count      = 0;
    this.cols            = _c.cols || 3; // 格子列数
    this.rows            = _c.rows || 3; // 格子行数
    this.grid_width      = _c.gridWidth || 50; // 格子宽
    this.grid_height     = _c.gridHeight || 50; // 格子高
    this.gap_x           = _c.gapX || 0; // 左右间隔
    this.gap_y           = _c.gapY || 0; // 上下间隔
    this.start_x         = _c.startX || 0; // 起始位置
    this.start_y         = _c.startY || 0;
    this.grid_items      = []; // 保存格子
    this.row_index       = _c.persistent ? _c.rowIndex : 0;
    this.back_row        = -1;
    this.col_index       = _c.persistent ? _c.colIndex : 0;
    this.back_col        = -1;
    this.grid_page       = _c.persistent ? _c.page || 0 : 0;
    this.grid_total_page = 0;
    this.isSeamless      = evm.isBoolean(_c.seamless)?_c.seamless:false;
    this.isBuilt         = false; // 是否已生成节点
    this.isDelayLoad     = true; // 延迟加载图片
    this.model           = _c.model || []; // 获取的对象的属性和一个可选的回调方法
    this.parent_node     = _c.parentNode || null;
    
    //====自定义事件的回调方法,在创建对象时传入对应的回调方法;=========================
    this.onBlur = _c.onBlur || hander;
    this.onChange = _c.onChange || hander;
    this.onChangeOut = _c.onChangeOut || hander;
    this.onFocus = _c.onFocus || hander;
    this.onSelect = _c.onSelect || hander;
    this.onEvent  = _c.onEvent || hander;
}

evm.extend(evm.ext.comp.Grid.prototype,{
    init : function(_d/*array*/) {
        var me = this;
        if(evm.isUndefined(_d))
            throw Error("Grid.init() needs an array parameter");
        
        me.config.data = _d;
        
        if(me.isBuilt) {
            me.row_index = 0;
            me.col_index = 0;
            me.grid_page = 0;
        }
        
        me.back_row = -1;
        me.back_col = -1;
        me.back_page = -1;
        me.grid_total_page = 0;
        
        var len = _d.length;
        
        if(len > 0) {
            me.grid_total_page = Math.ceil(len / (me.rows * me.cols)) - 1;
        }
        
        me.box_elem = evm.$(me.box_id);
        if(evm.isString(me.parent_node))
            me.parent_node = evm.$(me.parent_node);
        
        if(!me.box_elem) {
            // 动态生成
            me.box_elem = evm.createElem("div",
                {
                    id: me.box_id,
                    className : me.class_name,
                    style : ((me.config.style? me.config.style:'')+
                        "position:absolute;"+
                        "width:"+(me.cols*(me.grid_width+me.gap_x))+"px;"+
                        "height:"+(me.rows*(me.grid_height+me.gap_y))+"px;"+
                        "left:"+me.start_x+"px;"+
                        "top:"+me.start_y+"px;")
                },
                me.parent_node || document.body);
        }
        
        me.paint();
        
        return me;
    },
    paint: function() {
        var me = this,
            curGrid = null,
            curID = "",
            elem = null,
            tplHTML = "",
            prop = "",
            item = null,
            hasPaintCallback = false,
            tplStore;
        
        if(evm.isFunction(me.config.paintCallback)) {
            hasPaintCallback = true;
            tplStore = [];
        }
        
        if(!me.isBuilt) {
            me.isBuilt = !me.isBuilt;
            for(var r = 0; r<me.rows; ++r) {
                for(var c = 0; c<me.cols; ++c) {
                    css_value = "position:absolute;" +
                        "width:" + me.grid_width + "px;" +
                        "height:" + me.grid_height + "px;";
                        
                        if(r%2 === 0) {
                            // even
                            css_value += "left:" + (c*me.grid_width + me.gap_x*(c+1)) + "px;";
                        }
                        else{
                            // odd
                            if(me.isSeamless)
                                css_value += "left:" + ((me.cols - c -1 ) * me.grid_width + me.gap_x * ( me.cols - c)) + "px;";
                            else
                                css_value += "left:" + (c*me.grid_width + me.gap_x*(c+1)) + "px;";
                        }
                    
                    css_value += "top:" + (r*me.grid_height + me.gap_y*(r+1)) + "px;";
                    curID = me.box_id + "-r" + r + "-c" + c;
                    
                    elem  = evm.createElem("div", {
                            id : curID,
                            style : css_value
                        }, me.box_elem);
                }
            }
        }
        
        var start = me.grid_page * ( me.cols * me.rows ),
            data = me.config.data,
            len = data.length,
            num;
        
        for(var r = 0; r<me.rows; ++r) {
            for(var c = 0; c<me.cols; ++c) {
                prop = "";
                tplHTML = "";
                num = r * me.cols + c;
                curID = me.class_name + "-r" + r + "-c" + c;
                
                if(num + start < len) {
                    item = data[num+start];
                    if(me.config.model && me.config.model.length) {
                        for(var i=0; i<me.config.model.length; i++) {
                            prop = item[me.config.model[i].text];
                            if(evm.isFunction(me.config.model[i].callback)) {
                                prop = me.config.model[i].callback.call(me, prop, num+start, data, r, c);
                            }
                            tplHTML += prop;
                        }
                    }
                    else{
                        tplHTML = item;
                    }
                    
                }
                else{
                    tplHTML = prop;
                }
                
                if(hasPaintCallback)
                    tplStore.push(tplHTML);
                else
                    evm.html(evm.$(curID), tplHTML);
            }
        }
        
        if(hasPaintCallback)
            me.config.paintCallback(me.class_name, tplStore);
        
        return me;
    },
    isEmpty: function() {
        return this.config.data.length === 0;
    },
    getIndex: function() {
        var me = this,
            start = me.grid_page * (me.cols * me.rows);
        
        return  start + me.col_index + (me.row_index * me.cols);
    },
    getData: function() {
        return this.config.data;
    },
    getGrid: function(_r, _c) {
        var me = this,
            grid_ID = me.class_name + "-r" + _r + "-c" + _c;
        return evm.$(grid_ID);
    },
    thumb : function(_d) {
        // 翻页
        var me = this;
        if (_d === "RIGHT" || _d === "DOWN") {
            me.grid_page = ( me.grid_page + 1 + me.grid_total_page + 1 ) % ( me.grid_total_page + 1 );
        }
        else if (_d === "UP" || _d === "LEFT") {
            me.grid_page = ( me.grid_page - 1 + me.grid_total_page + 1 ) % ( me.grid_total_page + 1 );
        }
        me.row_index = 0;
        me.col_index = 0;
        me.paint();
    },
    move: function(_d) {
        var me = this,
            evt = null,
            start = me.grid_page * (me.cols * me.rows),
            len = me.config.data.length,
            col_limit,
            row_limit;
        
        me.back_row = me.row_index;
        me.back_col = me.col_index;
        me.back_page = me.grid_page;
        
        if(me.grid_page !== me.grid_total_page) {
            row_limit = me.rows;
            col_limit = me.cols;
        }
        else{
             row_limit = Math.ceil((len - start) / me.cols);
             col_limit = (len - me.cols * me.rows) % me.cols;
             if ( col_limit < 0 ) {
                 col_limit = len % me.cols
             }
             col_limit = (col_limit === 0 ? me.cols : col_limit);
        }
        
        evt = {
            type : "blur",
            dir : _d,
            row : me.row_index,
            col : me.col_index,
            back_col : me.back_col,
            back_row : me.back_row,
            page : me.grid_page,
            back_page : me.back_page,
            totalPage : me.grid_total_page,
            sid : me.getIndex(),
            rows : me.rows,
            cols : me.cols,
            rowLimit : row_limit,
            colLimit : col_limit
        };
        
        me.onEvent(evt);
        evt = null;
        
                
        if(_d === "LEFT") {
            me.col_index -= 1;
            if(me.col_index < 0)
                me.col_index = 0;
        }
        else if(_d === "RIGHT") {
            me.col_index += 1;
            if (me.row_index != row_limit -1) {
                if(me.col_index >= me.cols)
                    me.col_index = me.cols - 1;
            }
            else {
                if(me.col_index >= col_limit)
                    me.col_index = col_limit - 1;
            }
            
        }
        else if(_d === "UP") {
            me.row_index -= 1;
            if(me.row_index < 0)
                me.row_index = 0;
        }
        else if(_d === "DOWN") {
            me.row_index += 1;
            if(me.row_index  >= row_limit - 1) {
                me.row_index = row_limit - 1;
                var idx = me.col_index + me.row_index * me.cols + me.grid_page * ( me.rows *  me.cols);
                
                if ( idx > len -1) {
                    me.col_index = col_limit - 1;
                }
                
            }
        }
        
        evt = {
            type : "focus",
            dir : _d,
            row : me.row_index,
            col : me.col_index,
            back_col : me.back_col,
            back_row : me.back_row,
            page : me.grid_page,
            back_page : me.back_page,
            totalPage : me.grid_total_page,
            sid : me.getIndex(),
            rows : me.rows,
            cols : me.cols,
            rowLimit : row_limit,
            colLimit : col_limit
        };
        
        me.onEvent(evt);
        evt = null;
        
        return me;
    }

});
