/*
 * 组件
 * 10/07/15 : 配置对象增加paintCallback属性
 */

// 横向列表 焦点固定在某个位置上
evm.ext.comp.HFixedListBox = function(_c/*config object*/) {
    // 强制使用new
    if(this === evm.ext.comp || this === window) {
        return new arguments.callee(_c);
    }
    // 必须传参
    if(evm.isUndefined(_c) && !(evm.isObject(_c))) {
        throw Error('not found config');
    }
    
    function hander(_c/*event object*/){
        // 触发事件的默认方法
        try{
        //console.log('HFixedListBox 事件触发,默认处理方法');
        }catch(E){}
    
    }
  
    evm.ext.comp.BaseComponent.call(this, _c/*object*/);
    this.config          = _c; // 配置项
    this.box_width       = 0; //容器宽
    this.box_height      = 0; //容器高
    this.box_elem         = null; // 容器
    this.box_id          = _c.boxID || this.comp_name;
    this.max_list_num    = _c.maxLists || 6; // 容器最多显示的list个数
    this.list_count      = 0;
    this.list_width      = _c.listWidth || 0; // 列表宽度
    this.list_height     = _c.listHeight || 0; // 列表高度
    this.gap_x           = _c.gapX || 0; // 列表左右间隔
    this.gap_y           = _c.gapY || 0; // 列表上下间隔
    this.start_x         = _c.startX || 0; // 列表起始位置
    this.start_y         = _c.startY || 0;
    this.active_index    = 0; // 当前列表索引值
    this.back_index      = -1; // 上一个
    this.caption         = ''; // 列表标题
    this.isBuilt         = false; // 是否已生成节点
    this.offset          = _c.offset || 0; // 偏移
    this.model           = _c.model || []; // 获取的对象的属性和一个可选的回调方法
    this.emptyMsg        = _c.emptyMsg || "空";
    this.parent_node      = _c.parentNode || null;
    //====自定义事件的回调方法,在创建对象时传入对应的回调方法;=========================
    this.onBlur = _c.onBlur || hander;
    this.onChange = _c.onChange || hander;
    this.onChangeOut = _c.onChangeOut || hander;
    this.onFocus = _c.onFocus || hander;
    this.onSelect = _c.onSelect || hander;
    this.onEvent  = _c.onEvent || hander;
}

evm.extend(evm.ext.comp.HFixedListBox.prototype,{
    init : function(_d/*array*/) {
        // 调用init须传入数组
        var me = this
        ,i = 0
        ,model_len = me.model.length
        ,data
        ,len
        ,tplHTML = ''
        ,css_value;
    
        if(evm.isUndefined(_d)) {
            throw Error("HFixedListBox 配置对象未找到data");
        }
        
        me.config.data = _d;
        data = me.config.data;
        len = data.length;
        
        if(evm.isString(me.parent_node)) {
            me.parent_node = evm.$(me.parent_node);
        }
    
        me.box_elem = evm.$(me.box_id);
        //判断是否存在容器元素
        if(!me.box_elem) {
            me.box_elem = evm.createElem('div', {
                id: me.box_id
                ,className: me.class_name
            }, me.parent_node || document.body);
        }
    
        if(!me.isBuilt) {
            //动态生成节点
            me.isBuilt = !me.isBuilt;
            while(i<me.max_list_num) {
                css_value = 'position:absolute;width:'+(me.list_width)+'px;'
                    +'height:'+(me.list_height)+'px;'
                    +'left:'+(i*(me.list_width+me.gap_x))+'px;'
                    +'line-height:'+(me.list_height)+'px;overflow:hidden;';
                    
                tplHTML += '<div class="'+me.class_name+'-list" '
                    +'id="'+me.class_name+'-list-'+(i)+'" '
                    +'style="'+css_value+'"></div>';
                    
                i+=1;
            };
            evm.html(me.box_elem, tplHTML);
            
            css_value = {
                "width":(me.list_width+me.gap_x)*me.max_list_num + 'px'
                ,"height":(me.list_height+me.gap_y) + 'px'
                ,"position":"absolute"
                ,"left":me.start_x + "px"
                ,"top":me.start_y + "px"
            };
            
            //设置box_elem样式
            if(evm.isString(me.config.style)) {
                evm.cssText(me.box_elem, me.config.style);
            }
            
            evm.css(me.box_elem, css_value);
        }
        me.paint();
        return me;
    }
    ,paint: function() {
        var me = this
        ,i = 0
        ,j = 0
        ,hasPaintCallback = false
        ,tplStore
        ,data = me.config.data
        ,len = data.length
        ,limit = 0
        ,tplHTML = ''
        ,prop;
     
        if(len < me.max_list_num) {
            limit = len;
        }
        else{
            limit = me.max_list_num;
        }
        
        if(evm.isFunction(me.config.paintCallback)) {
            hasPaintCallback = true;
            tplStore = [];
        }
    
        for(var i=0; i<limit; i++) {
            tplHTML = '';
            if(me.model.length>0) {
                for(var j=0; j<me.model.length; j++) {
                    prop = data[(me.active_index + i + me.offset+len)%len][me.model[j].text];
                    
                    if(evm.isFunction(me.model[j].callback)) {
                        prop = me.model[j].callback(prop, i, data, me.model[j].text);
                    }
                    tplHTML += prop;
                }
            }
            else{
                prop = data[(me.active_index + i+me.offset+len)%len];
                tplHTML = prop;
            }
            
            if(hasPaintCallback) {
                tplStore.push(tplHTML);
            }
            else{
                evm.html(evm.$(me.class_name+'-list-'+i),tplHTML);
            }
        }
        
        if(hasPaintCallback) {
            me.config.paintCallback(me.class_name+'-list-', tplStore);
        }
        
        return me;
    }
    ,moveH: function(_d/*string:'LEFT'or'RIGHT'*/) {
        var me = this
        ,length = me.config.data.length
        ,size = me.max_list_num;
        
        var evt = {
            index: me.active_index
            ,size: size
            ,dir: _d
            ,type: 'blur'
        };
        
        me.onBlur(evt);
        me.onEvent(evt);
        if(_d === "LEFT") {
            var val = -1;
        }
        else if(_d === "RIGHT") {
            var val = 1;
        }
        
        me.active_index = (me.active_index + val + length) % length;
        var evt = {
            index: me.active_index
            ,size: size
            ,dir: _d
            ,type: 'focus'
        };
        me.onFocus(evt);
        me.onEvent(evt);
        return me;
    }
    ,isEmpty: function() {
        return this.config.data.length === 0;
    }
    ,getData: function() {
        return this.config.data;
    }
    ,getIndex: function() {
        var me = this;
        return me.active_index;
    }
    ,setIndex: function(_n/*number*/) {
        var me = this;
        me.active_index = _n;
        return me;
    }
    ,action: function(_d) {
        var me = this;
        switch(_d) {
            case "UP":
            case "DOWN":
                me.onBlur({type:'blur', index: me.active_index, dir:_d});
                break;
            case "LEFT":
                me.moveH(_d);
                break;
            case "RIGHT":
                me.moveH(_d);
                break;
            case "SELECT":
                me.onSelect({index: me.active_index, dir:_d});
                break;
            default:
        }
        return me;
    }
});
