/*
 * 键盘2
 * create by yangty@evmtv.com on 20 Feb, 2017
 */

evm.ext.comp.Keyboard2 = function ( _c ) {
	// 强制使用new
	if(this === evm.ext.comp || this === window) {
		return new arguments.callee( _c );
	}
	// 必须传参
	if(evm.isUndefined(_c) && !(evm.isObject(_c))) {
		throw Error('not found config parameter');
	}
  
	function hander(_c){
		// 触发事件的默认方法
		try{
			//console.log('Keyboard 事件触发,默认处理方法');
		}catch(E){};
	}

	evm.ext.comp.BaseComponent.call(this, _c);
	this.config				= _c;
	this.box_elem			= null;
	this.box_id				= _c.boxID || this.comp_name;
	this.parent_node		= _c.parentNode || null;
	this.box_width			= _c.keyboardWidth || 288;
	this.box_height			= _c.keyboardHeight || 330;
	this.circle_id		= _c.boxID+'-circle';
	this.circle_width		= _c.circleWidth || 129;
	this.circle_height		= _c.circleHeight || 129;
	this.circle_offset_x	= _c.circleOffsetX || -20;
	this.circle_offset_y	= _c.circleOffsetY || -24;
	this.cell_width			= 0;
	this.cell_height		= 0;
	this.col_index			= 0;
	this.row_index			= 0;
	this.back_col_index		= -1;
	this.back_row_index		= -1;
	this.cols				= _c.cols || 3;
	this.rows				= _c.rows || 4;
	this.box_x				= _c.x || 100;
	this.box_y				= _c.y || 100;
	this.gap_x				= _c.gapX || 1;
	this.gap_y				= _c.gapY || 3;
	this.paddingLeft		= _c.paddingLeft || 9;
	this.paddingRight		= _c.paddingRight || 8;
	this.paddingTop			= _c.paddingTop || 8;
	this.paddingBottom		= _c.paddingBottom || 10;
	this.bkg_source			= _c.bkgSource || '/swatapps/ape/source/img/keyboard/keyboard-bkg.png';
	this.circle_source		= _c.circleSource || '/swatapps/ape/source/img/keyboard/keyboard-cell.png';
	this.animate_switch 	= (typeof _c.animate=='boolean'?_c.animate:true);
	this.keyboardVisible	= false;
	this.is_build			= false;
	this.circleVisible		= false;
	this.capital_flag		= (typeof _c.capital=='boolean'?_c.capital:false);
	this.cell_arr			= [];
	this.circle_index		= 0;
	this.circle_model		= ['center', 'left', 'up', 'right', 'bottom'];
	this.circle_txt_style	= [{x:50,y:49},{x:8,y:49},{x:50,y:8},{x:88,y:49},{x:50,y:90}];
	this.circle_arr			= [];
	this.circle_config		= '';
	this.circle_ext_config	= _c.circleConfig || null;
	this.keyFocusStyle		= '#FFFFFF';
	this.keyBlurStyle		= '#555555';
	this.keyBGFocusStyle	= '#346BDB';
	this.keyBGBlurStyle		= 'transparent';
	this.keyboard_style		= _c.keyboardStyle || '';
	this.key_style			= _c.keyStyle || '';
	this.extKey_style		= _c.extKeyStyle || '';
	this.keyMap				= _c.keyMap || evm.ext.comp.Keyboard2.keyMap;
	//====自定义事件的回调方法,在创建对象时传入对应的回调方法;==========================
	this.onBlur = _c.onBlur || hander;
	this.onChange = _c.onChange || hander;
	this.onChangeOut = _c.onChangeOut || hander;
	this.onFocus = _c.onFocus || hander;
	this.onSelect = _c.onSelect || hander;
	this.onEvent = _c.onEvent || hander;
}

evm.ext.comp.Keyboard2.keyMap = {
items:[[
	{key:'1', extKey:['.','@',',']},
	{key:'2', extKey:['a','b','c']},
	{key:'3', extKey:['d','e','f']} ],
	[{key:'4', extKey:['g','h','i']},
	{key:'5', extKey:['j','k','l']},
	{key:'6', extKey:['m','n','o']} ],
	[{key:'7', extKey:['p','q','r','s']},
	{key:'8', extKey:['t','u','v']},
	{key:'9', extKey:['w','x','y','z']} ],
	[{key:'*', extKey:[]},
	{key:'0', extKey:[]},
	{key:'#', extKey:[]} ]]};

evm.extend(evm.ext.comp.Keyboard2.prototype, {
	init: function() {
		var me = this,
			styleValue = '',
			hasDisplay = /\s*display:\s*block\s*/g;
		
		me.cell_width = Math.floor((me.box_width-me.paddingLeft-me.paddingRight-me.gap_x*me.cols*2)/me.cols );
		me.cell_height = Math.floor((me.box_height-me.paddingTop-me.paddingBottom-me.gap_y*me.rows*2)/me.rows );
		me.box_elem = evm.$(me.box_id);
		
		if(evm.isString(me.parent_node)) {
			me.parent_node = evm.$(me.parent_node);
		}
		
		if(!me.box_elem) {
			styleValue = 'position:absolute;width:'+this.box_width+
				'px;height:'+this.box_height+'px;left:'+this.box_x+'px;top:'+
				this.box_y+'px;display:'+(me.keyboardVisible?'block':'none')+
				';background:url('+me.bkg_source+');text-align:center';
			
			me.box_elem = evm.createElem("div", {
				id: me.box_id,
				className : me.class_name,
				style : (me.keyboard_style ? styleValue+';'+me.keyboard_style:styleValue)
			}, me.parent_node || document.body);
			if ( me.keyboard_style && hasDisplay.test(me.keyboard_style) ) {
				me.keyboardVisible = true;
			}
			
		}
		
		if(me.animate_switch) {
			evm.css(me.box_elem, {"-webkit-transition-duration":"200ms"});
		}
		
		me.paint();
		
		setTimeout( function(){
			me.toggleFocus( me.row_index, me.col_index, 'show' );
		}, 100 );
		return me;
	},
	paint: function() {
		var me = this,
			r = 0,
			c = 0,
			x = 0,
			y = 0,
			keyVal = '',
			extKeyVal = '',
			styleValue = '',
			templateStr = '',
			keyStyleVal = '',
			extKeyStyleVal = '';
		
		keyStyleVal = 'font-size:30px;width:'+me.cell_width+'px;height:'+me.cell_height+'px;line-height:'+me.cell_height+'px;text-align:center;'+me.key_style;
		
		extKeyStyleVal = 'position:absolute;width:100%;top:0px;font-size:18px;text-align:center;'+me.extKey_style;
		
		if ( !me.is_build ) {
			me.is_build = true;
			for (; r<me.rows; ++r){
				me.cell_arr[ r ] = [];
				for(c=0; c<me.cols; ++c) {
					x = me.paddingLeft+c*me.cell_width+((c+1)*2-1)*me.gap_x;
					y = me.paddingTop+r*me.cell_height+((r+1)*2-1)*me.gap_y;
					me.cell_arr[ r ].push({x:x,y:y});
					styleValue = 'position:absolute;left:'+x+'px;'+
						'top:'+y+'px;width:'+me.cell_width+'px;'+
						'height:'+me.cell_height+'px';
					templateStr += '<div id="'+me.box_id+'-r'+r+'-c'+c+'" style="'+styleValue+'">'+
						'<div id="'+me.box_id+'-key-r'+r+'-c'+c+'" style="'+keyStyleVal+'"></div>'+
						'<div id="'+me.box_id+'-extKey-r'+r+'-c'+c+'" style="'+extKeyStyleVal+'"></div></div>'
				}
			}
			templateStr += '<div id="'+me.circle_id +'" style="position:absolute;'+
				'background:url('+me.circle_source+');'+
				'width:'+me.circle_width+'px;height:'+me.circle_height+'px;'+
				'left:0px;top:0px;display:'+(me.circleVisible?'block':'none')+';">';
			
			for ( var i = 0; i < me.circle_model.length; ++i ) {
				templateStr += '<div id="'+me.circle_id+'-'+me.circle_model[i]+
					'-box" style="position:absolute;left:0px;top:0px;'+
					'width:'+me.circle_width+'px;height:'+me.circle_height+'px;">'+
						'<div id="'+me.circle_id+'-'+me.circle_model[i]+'-bkg" style="'+
						'width:100%;height:100%;display:none;'+
						'background:url(../source/img/keyboard/keyboard-'+me.circle_model[i]+'.png)"></div>'+
						'<div id="'+me.circle_id+'-'+me.circle_model[i]+'-txt" style="'+
						'position:absolute;left:'+me.circle_txt_style[i].x+'px;top:'+me.circle_txt_style[i].y+'px;width:30px;text-align:center;line-height:30px;"></div></div>';
			}
			
			evm.html(me.box_elem, templateStr);
		}
		
		for ( r=0; r<me.keyMap.items.length; ++r) {
			for ( c=0; c<me.keyMap.items[r].length; ++c) {
				keyVal = me.keyMap.items[r][c].key.toString();
				extKeyVal = me.keyMap.items[r][c].extKey.join(' ');
				evm.html(evm.$(me.box_id+'-key-r'+r+'-c'+c), me.capital_flag?keyVal.toUpperCase():keyVal);
				evm.html(evm.$(me.box_id+'-extKey-r'+r+'-c'+c), me.capital_flag?extKeyVal.toUpperCase():extKeyVal);
			}
			
		}
		return me;
	},
	moveTo: function( x, y ) {
		var me = this;
		
		me.box_x = x;
		me.box_y = y;
		evm.css(me.box_elem, {
			left : (x + 'px'),
			top : (y + 'px')
		});
		return me;
	},
	toggle: function( d ) {
		var me = this;
		
		if ( typeof d != 'string' ) {
			me.keyboardVisible = !me.keyboardVisible;
		}
		else {
			me.keyboardVisible = (d=='hide'?false:true)
		}
		
		evm.css(me.box_elem, {display : (me.keyboardVisible?'block':'none')});
		return me;
	},
	toggleFocusTimer: -1,
	toggleFocus: function( r, c, d ) {
		var me = this,
			elem = evm.$(me.box_id + '-r' + r + '-c' + c);
		if ( elem ) {
			evm.css( elem, {
				'backgroundColor':(d=='show'?me.keyBGFocusStyle:me.keyBGBlurStyle),
				'color':(d=='hide'?me.keyBlurStyle:me.keyFocusStyle)
			});
		}
		return me;
	},
	toggleCircle: function( d ) {
		var me = this;
		
		if ( typeof d != 'string' ) {
			me.circleVisible = !me.circleVisible
		}
		else {
			me.circleVisible = (d=='hide'?false:true);
		}
		
		evm.css( evm.$( me.circle_id ), {display: (me.circleVisible?'block':'none')} );
		return me;
	},
	toggleCircleFocus: function( n, d ) {
		var me = this;
		evm.css(evm.$(me.circle_id+'-'+me.circle_model[n]+'-bkg'), {
			display: (d=='hide'?'none':'block')
		});
		evm.css(evm.$(me.circle_id+'-'+me.circle_model[n]+'-txt'), {
			color: (d=='hide'?'#000000':'#FFFFFF')
		});
		return me;
	},
	keyAction: function( d ) {
		var me = this,
			key = null,
			result = false;
		
		clearTimeout( me.toggleFocusTimer );
		d = d.toUpperCase();

		if ( d == 'SELECT' ) {
			key = me.keyMap.items[ me.row_index ][ me.col_index ];
			if ( key.extKey.length > 0 ) {
				return me.initCircleContent();
			}
			else {
				return key.key;
			}
		}
		if ( d == 'UP' ) {
			me.back_row_index = me.row_index;
			me.toggleFocus( me.row_index, me.col_index, 'hide');
			me.row_index -= 1;
			if(me.row_index < 0) {
				me.row_index = 0;
			}
		}
		else if ( d == 'DOWN' ) {
			me.back_row_index = me.row_index;
			me.toggleFocus( me.row_index, me.col_index, 'hide');
			me.row_index += 1;
			if(me.row_index > me.rows-1 ) {
				me.row_index = me.rows-1;
			}
		}
		else if ( d == 'LEFT' ) {
			me.back_col_index = me.col_index;
			me.toggleFocus( me.row_index, me.col_index, 'hide');
			me.col_index -= 1;
			if(me.col_index < 0) {
				me.col_index = 0;
			}
		}
		else if ( d == 'RIGHT' ) {
			me.back_col_index = me.col_index;
			me.toggleFocus( me.row_index, me.col_index, 'hide');
			me.col_index += 1;
			if(me.col_index > me.cols - 1) {
				me.col_index = me.cols - 1;
			}
		}
		else {
			me.back_col_index = me.col_index;
			me.back_row_index = me.row_index;
			result = me.setIteratorByKeyName( d );
			if ( !result ) { return me;}
		}

		if ( result ) {
			me.toggleFocus( me.back_row_index, me.back_col_index, 'hide');
		}
		
		me.toggleFocusTimer = setTimeout(function(){
			me.toggleFocus( me.row_index, me.col_index, 'show');
		}, 40);

		return me;
	},
	circleAction: function( d ) {
		var me = this,
			result = null;
		
		if ( d == 'SELECT' ) {
			
			result = me.circle_arr[ me.circle_index ];
			if ( me.capital_flag ) result = result.toUpperCase();
			me.toggleCircleFocus( me.circle_index, 'hide' );
			me.toggleCircle( 'hide' );
			me.circle_index = 0;
			return result;
		}
		else if ( d == 'LEFT' ) {
			if ( me.circle_index === 0 ) {
				me.toggleCircleFocus( me.circle_index, 'hide' );
				me.circle_index += 1;
				me.toggleCircleFocus( me.circle_index, 'show' );
			}
			if ( me.circle_index === 3 ) {
				me.toggleCircleFocus( me.circle_index, 'hide' );
				me.circle_index = 0;
				me.toggleCircleFocus( me.circle_index, 'show' );
			}
		}
		else if ( d == 'UP' ) {
			if ( me.circle_index === 0 && me.circle_arr.length > 2 ) {
				me.toggleCircleFocus( me.circle_index, 'hide' );
				me.circle_index += 2;
				me.toggleCircleFocus( me.circle_index, 'show' );
			}
			if ( me.circle_index === 4 ) {
				me.toggleCircleFocus( me.circle_index, 'hide' );
				me.circle_index = 0;
				me.toggleCircleFocus( me.circle_index, 'show' );
			}
		}
		else if ( d == 'RIGHT' ) {
			if ( me.circle_index === 0 && me.circle_arr.length > 3 ) {
				me.toggleCircleFocus( me.circle_index, 'hide' );
				me.circle_index += 3;
				me.toggleCircleFocus( me.circle_index, 'show' );
			}
			if ( me.circle_index === 1 ) {
				me.toggleCircleFocus( me.circle_index, 'hide' );
				me.circle_index = 0;
				me.toggleCircleFocus( me.circle_index, 'show' );
			}
		}
		else if ( d == 'DOWN' ) {
			if ( me.circle_index === 0 && me.circle_arr.length > 4 ) {
				me.toggleCircleFocus( me.circle_index, 'hide' );
				me.circle_index += 4;
				me.toggleCircleFocus( me.circle_index, 'show' );
			}
			if ( me.circle_index === 2 ) {
				me.toggleCircleFocus( me.circle_index, 'hide' );
				me.circle_index = 0;
				me.toggleCircleFocus( me.circle_index, 'show' );
			}
		}
		
	},
	setIteratorByKeyName: function( keyName ) {
		var me = this;
		
		for ( var i = 0; i < me.keyMap.items.length; ++i ) {
			for ( var j = 0; j < me.keyMap.items[ i ].length; ++j )
			if ( me.keyMap.items[i][j].key == keyName.substr(-1) ) {
				me.row_index = i;
				me.col_index = j;
				return true;
			}
		}
		return false;
	},
	initCircleContent: function() {
		var me = this,
			templateStr = '',
			key = me.keyMap.items[ me.row_index ][ me.col_index ],
			cell = me.cell_arr[ me.row_index ][ me.col_index ];
		
		me.circle_index = 0;
		me.circle_arr = [];
		me.circle_arr.push( me.capital_flag?key.key.toUpperCase():key.key );
		for ( var i = 0; i < key.extKey.length; ++i ) {
			me.circle_arr.push( me.capital_flag?key.extKey[ i ].toUpperCase():key.extKey[ i ] );
		}
		for ( i = 0; i < me.circle_model.length; ++i ) {
			if ( me.circle_arr[ i ] ) {
				evm.html( evm.$(me.circle_id+'-'+me.circle_model[i]+'-txt'), me.circle_arr[ i ]);
			}
			else {
				evm.html( evm.$(me.circle_id+'-'+me.circle_model[i]+'-txt'), '');
			}
		}
		
		me.toggleCircle( 'show' );
		me.setCirclePosition( cell.x, cell.y );
		me.toggleCircleFocus( me.circle_index, 'show' );
		return null;
			
	},
	setCirclePosition: function( x, y ) {
		var me = this;
		x = x + me.circle_offset_x;
		y = y + me.circle_offset_y;
		evm.css( evm.$( me.circle_id), {left:(x+'px'), top:(y+'px')});
		return me;
	},
	action: function( d ) {
		var me = this;
		
		if ( me.circleVisible ) {
			return me.circleAction( d );
		}
		else {
			return me.keyAction( d );
		}
	},
	doSelect: function() {
		var me = this;
		if ( me.circleVisible ) {
			return me.circleAction( 'SELECT' );
		}
		else {
			return me.keyAction( 'SELECT' );
		}
	}
});

