/*
 * 滚动条
 * create by yangty@evmtv.com on 4 June, 2015
 */

evm.ext.comp.ScrollerBar = function(_c/*config object*/) {
    // 强制使用new
    if(this === evm.ext.comp || this === window) {
        return new arguments.callee(_c);
    }
    // 必须传参
    if(evm.isUndefined(_c) && !(evm.isObject(_c))) {
        throw Error('not found config parameter');
    }
  
    function hander(_c/*event object*/){
        // 触发事件的默认方法
    }
    evm.ext.comp.BaseComponent.call(this, _c/*object*/);
    this.config           = _c; // 配置项
    this.wrapper_elem     = null; // 容器
    this.wrapper_id       = _c.wrapperID || this.comp_name;
    this.scroller_elem    = null;
    this.scroller_id      = this.wrapper_id +'-scrollerBar';
    this.size             = 0;
    this.wrapper_width    = 0;
    this.wrapper_height   = 0;
    this.scroller_width   = 0;
    this.scroller_height  = 0;
    this.scroller_offset  = 0;
    this.start_x          = 0;
    this.start_y          = 0;
    this.mode             = _c.mode || 'vertical'; // 垂直或水平模式
    this.animate_switch   = true;
    this.parent_node      = _c.parentNode || null;
    //====自定义事件的回调方法,在创建对象时传入对应的回调方法;==========================
    this.onBlur = _c.onBlur || hander;
    this.onChange = _c.onChange || hander;
    this.onChangeOut = _c.onChangeOut || hander;
    this.onFocus = _c.onFocus || hander;
    this.onSelect = _c.onSelect || hander;
    this.onEvent = _c.onEvent || hander;
};

evm.extend(evm.ext.comp.ScrollerBar.prototype, {
    init: function(_s/*number*/) {
        var me = this;
        if(evm.isNumber(_s)) {
            me.config.size = _s;
        }
        
        me.size = me.config.size || 0;
        if(me.size === 0) return me;
        me.start_x = me.config.startX || 0;
        me.start_y = me.config.startY || 0;
        me.wrapper_width = me.config.wrapperWidth || 20;
        me.wrapper_height = me.config.wrapperHeight || 200;
        me.wrapper_bg = me.config.wrapperBg || '#ccc';
        me.scroller_bg = me.config.scrollerBg || '#000';
        if(me.mode === 'vertical') {
            me.scroller_width = me.config.scrollerWidth || (me.wrapper_width - 2);
            me.scroller_height = Math.max(20,Math.floor(me.wrapper_height/me.size));
            me.scroller_offset = (me.wrapper_height - me.scroller_height)/(me.size-1);
        }
        else if(me.mode === 'horizon') {
            me.scroller_height = me.config.scrollerHeight || (me.wrapper_height - 2);
            me.scroller_width = Math.max(20,Math.floor(me.wrapper_width/me.size));
            me.scroller_offset = (me.wrapper_width - me.scroller_width)/(me.size-1);
        }
        
        
        me.animate_switch = evm.isBoolean(me.config.animate)?
                            me.config.animation : me.animate_switch;
    
        if(evm.isString(me.parent_node)) {
            me.parent_node = evm.$(me.parent_node);
        }
        me.wrapper_elem = evm.$(me.wrapper_id);
        if(!me.wrapper_elem) {
            me.wrapper_elem = evm.createElem('div', {
                id: me.wrapper_id
                ,className : me.class_name
            }, me.parent_node || document.body);
        }
    
        if(!me.scroller_elem) {
            me.scroller_elem = evm.createElem('div', {
                id: me.scroller_id
            }, me.wrapper_elem);
        }
    
        evm.css(me.wrapper_elem, {
            'width': me.wrapper_width + 'px'
            ,'height':me.wrapper_height + 'px'
            ,'position':'absolute'
            ,'left':me.start_x + 'px'
            ,'top':me.start_y + 'px'
            ,'background': me.wrapper_bg
        });
    
        if(me.animate_switch) {
            evm.css(me.scroller_elem, {
                '-webkit-transition-duration': '200ms'
            });
        }
        //var left_offset = Math.floor((me.wrapper_width - me.scroller_width)/2);
        evm.css(me.scroller_elem, {
            'width': me.scroller_width + 'px'
            ,'height':me.scroller_height + 'px'
            ,'position':'absolute'
            ,'background':me.scroller_bg
            ,'top': '0px'
        });
    
    }
    ,setScrollerPosition: function(_n/*number*/) {
        var me = this;
        if(me.mode === 'vertical') {
            evm.css(me.scroller_elem, {"top":(me.scroller_offset*_n)+"px"});
        }
        else if(me.mode === 'horizon'){
            evm.css(me.scroller_elem, {"left":(me.scroller_offset*_n)+"px"});
        }
        
        return me;
    }
    ,toggle: function(_d/*string:'show' or 'hide'*/) {
        var me = this;
        evm.css(me.wrapper_elem, {"display":(_d==='show'?"block":"none")});
    }
});