/**
 * 组件
 * 提示框
 */

//
evm.ext.comp.TipBox3 = function(_c) {
    // 强制使用new
    if(this === evm.ext.comp || this === window) {
        return new arguments.callee(_c);
    }

    function hander(_c){
        // 触发事件的默认方法
        try{
        //console.log('TipBox 事件触发,默认处理方法');
        }catch(E){}

    }

    evm.ext.comp.BaseComponent.call(this, _c);
    this.config             = _c||{}; // 配置项
    this.box_id             = _c&&_c.boxID || this.comp_name;
    this.box_elem           = null;
    this.box_x              = _c&&_c.x || 320;
    this.box_y              = _c&&_c.y || 140;
    this.box_width          = _c&&_c.width || 434;
    this.box_height         = _c&&_c.height || 255;
    this.activeIndex        = 0;
    this.timer              = -1;
    this.buttonIcon         = [
        {name:'confirm', focus:'#31555b', blur:'#47696f'}
        ,{name:'cancel', focus:'#31555b', blur:'#47696f'}
    ];
    this.parent_node        = (_c&&_c.parent_node) || (_c&&_c.parentNode) || null;
    this.timer              = -1;
    //====自定义事件的回调方法,在创建对象时传入对应的回调方法;=========================
    this.onBlur = _c&&_c.onBlur || hander;
    this.onChange = _c&&_c.onChange || hander;
    this.onChangeOut = _c&&_c.onChangeOut || hander;
    this.onFocus = _c&&_c.onFocus || hander;
    this.onSelect = _c&&_c.onSelect || hander;
    this.onEvent  = _c&&_c.onEvent || hander;
}

evm.extend(evm.ext.comp.TipBox3.prototype,{
    init: function(_c) {
        var me = this;
        clearTimeout( me.timer );
        if(typeof me.parent_node === 'string') {
            me.parent_node = evm.$(me.parent_node);
        }
        if(!me.parent_node) {
            me.parent_node = document.body;
        }
        if(!me.box_elem) {
            me.box_elem = evm.createElem('div', {
                id: me.box_id
                ,className: me.class_name
                ,style: 'position:absolute;color:#FFF;font-size:24px;'
                        +'left:'+me.box_x+'px;'
                        +'top:'+me.box_y+'px;'
                        +'width:'+me.box_width+'px;'
                        +'height:'+me.box_height+'px;'
                        +'background:#4C737A'
            }, me.parent_node);
        }

        if(!me.box_title_elem) {
            me.box_title_elem = evm.createElem('div', {
                className: me.class_name+'-title'
                ,style: 'position: absolute;'
                        +'width:84%; height:50px;line-height:50px;'
                        +'left:8%;top:3px;text-align:center'
            }, me.box_elem);
        }

        if(!me.box_msg_elem) {
            me.box_msg_elem = evm.createElem('div', {
                className: me.class_name+'-msg'
                ,style: 'position:absolute;width:84%;height:100px;color:#FFF;'
                        +'left:8%;top:75px;line-height:30px;text-align:center'
            }, me.box_elem);
        }

        if(!me.box_buttons_elem) {
            me.box_buttons_elem = evm.createElem('div', {
                className: me.class_name+'-buttons'
                ,style: 'position: absolute;left:0px;top:209px;'
                        +'width:100%;height:40px;text-align:center'
            }, me.box_elem);

        }

        if(_c.title) {
            evm.html(me.box_title_elem, _c.title);
        }
        if(_c.msg) {
            evm.html(me.box_msg_elem, _c.msg);
        }

        if(_c.buttons && _c.buttons.length > 0) {
            // 根据buttons个数显示按钮

            me.config.buttons = _c.buttons;
            me.activeIndex = 0;

            if(!me.box_button_confirm) {
                me.box_button_confirm = evm.createElem('div', {
                    className: me.class_name+'-sub'
                    ,style: 'display:inline-block;width:216px;height:40px;padding:4px 0;background:'+me.buttonIcon[0].blur
                }, me.box_buttons_elem);
                setTimeout(function(){
	                me.box_button_confirm.innerHTML = '确定';
                }, 60);
            }

            if(!me.box_button_cancel) {
                me.box_button_cancel = evm.createElem('div', {
                    className: me.class_name+'-sub'
                    ,style: 'display:inline-block;width:216px;height:40px;padding:4px 0;background:'+me.buttonIcon[0].blur
                }, me.box_buttons_elem);
                setTimeout(function(){
	                me.box_button_cancel.innerHTML = '取消';
                }, 60);
            }


            if(_c.buttons.length === 1) {
                evm.css(me.box_button_cancel, {
                    display: 'none'
                });
            }
            else if(_c.buttons.length >= 2) {
                evm.css(me.box_button_cancel, {
                    display: 'inline-block'
                });
            }

            evm.toggleDisplay(me.box_buttons_elem,'show');
            me.toggle('show');

            me.timer = setTimeout(function() {
                me.toggleFocus(me.activeIndex, 'focus');
                me.addListener();
            }, 40);

        }
        else{
            // 没有按钮
            me.config.buttons = null;
            evm.toggleDisplay(me.box_buttons_elem,'hide');

            if(_c.timeout > 0) {
                // 配置对象有超时时间
                me.timer = setTimeout(function() {
                    me.toggle('hide');
                    if(evm.isFunction(_c.callback)) {
                        // 配置对象有回调函数
                        _c.callback();
                    }
                }, _c.timeout);
            }
            else{
                if(evm.isFunction(_c.callback)) {
                    // 配置对象有回调函数
                    _c.callback();
                }
            }
        }

        return me;
    }
    ,paint: function( _c ) {
        var me = this;

        if ( _c.title ) {
            evm.html(me.box_title_elem, _c.title);
        }
        if ( _c.msg ) {
            evm.html(me.box_msg_elem, _c.msg);
        }

        return me;
    }
    ,toggle: function(_d) {
        var me = this;
        evm.toggleDisplay(me.box_elem, _d);
        if(_d === 'hide') {
            if(me.config.buttons)
                me.removeListener();
        }
        return me;
    }
    ,toggleFocus: function(_n, _d) {
        var me = this
        ,elem = null;

        if(_n === 0) {
            me.box_button_confirm.style.background = me.buttonIcon[0][_d];
        }
        else{
            me.box_button_cancel.style.background = me.buttonIcon[1][_d];
        }

        return me;
    }
    ,move: function(_d) {
        var me = this
        ,buttonNumber = me.config.buttons.length;

        if(_d === 'LEFT') {
            if(me.activeIndex > 0) {
                me.toggleFocus(me.activeIndex, 'blur');
                me.activeIndex -= 1;
                me.toggleFocus(me.activeIndex, 'focus');
            }
        }
        else{
            if(me.activeIndex < buttonNumber-1) {
                me.toggleFocus(me.activeIndex, 'blur');
                me.activeIndex += 1;
                me.toggleFocus(me.activeIndex, 'focus');
            }
        }
        return me;
    }
    ,moveTo: function(x, y) {
        // 移动提示框到指定的(x,y)位置
        var me = this;
        if(!evm.isNumber(x) || !evm.isNumber(y)) return false;
        evm.css(me.box_elem, {
            left: x+'px'
            ,top: y+'px'
        });
        return true;
    }
    ,grabEvent: function(_v, _e) {
        var me = this
        ,isBlock = 0
        ,buttonNumber = me.config.buttons.length;
        switch(_e.alias) {
            case 'RIGHT':
            case 'LEFT':
                me.move(_e.alias);
                break;
            case 'SELECT':
                var cb = me.config.buttons[me.activeIndex].callback;
                if(evm.isFunction(cb)) {
                    cb();
                }
                me.toggleFocus(me.activeIndex, 'blur');
                me.toggle('hide');
                break;
        }
        return isBlock;
    }
    ,addListener: function() {
        var me = this;
        evm.controller.subscribe({
            type: 0,
            method: 'add',
            callback: me.grabEvent,
            context: me
        });
    }
    ,removeListener: function() {
        var me = this;
        evm.controller.subscribe({
            type: 1,
            method: 'remove',
            callback: me.grabEvent,
            context: me
        });
    }
});
