/*
 * 组件
 * evm.ext.comp.VListBox的通用版
 */

// [焦点可移动]竖向列表
evm.ext.comp.VListBox_v2 = function(_c) {
    // 强制使用new
    if(this === evm.ext.comp || this === window)
        return new arguments.callee(_c);
    
    // 必须传参
    if(evm.isUndefined(_c) && !(evm.isObject(_c)))
        throw Error("not found config parameter");
    
    function hander(_c){
        // 触发事件的默认方法
        try{
          // console.log('VListBox 事件触发,默认处理方法');
        }catch(E){}
    
    }
  
    evm.ext.comp.BaseComponent.call(this, _c);
    this.config          = _c; // 配置项
    this.box_width       = _c.boxWidth || 0; //容器宽
    this.box_height      = _c.boxHeight || 0; //容器高
    this.box_elem         = null; // 容器
    this.box_id          = _c.boxID || this.comp_name;
    this.max_list_num    = _c.maxLists || 6; // 容器最多显示的list个数
    this.list_count      = 0;
    this.list_width      = _c.listWidth || 0; // 列表宽度
    this.list_height     = _c.listHeight || 0; // 列表高度
    this.gap_x           = _c.gapX || 0; // 列表左右间隔
    this.gap_y           = _c.gapY || 0; // 列表上下间隔
    this.start_x         = _c.startX || 0; // 列表起始位置
    this.start_y         = _c.startY || 0;
    this.active_index    = _c.persistent ? _c.activeIndex?_c.activeIndex:0 : 0; // 当前列表索引值
    this.list_page       = _c.persistent ? _c.listPage?_c.listPage:0 : 0;
    this.back_page       = -1;
    this.list_total_page = 0;
    this.isBuilt         = false; // 是否已生成节点
    this.back_index      = -1; // 记录之前的索引
    this.model           = _c.model || []; // 获取的对象的属性和一个可选的回调方法
    this.emptyMsg        = _c.emptyMsg || "空";
    this.parent_node     = _c.parent_node || _c.parentNode || null;
    //====自定义事件的回调方法,在创建对象时传入对应的回调方法;==========================
    this.onBlur = _c.onBlur || hander;
    this.onChange = _c.onChange || hander;
    this.onChangeOut = _c.onChangeOut || hander;
    this.onFocus = _c.onFocus || hander;
    this.onSelect = _c.onSelect || hander;
    this.onEvent  = _c.onEvent || hander;
  
}

evm.extend(evm.ext.comp.VListBox_v2.prototype,{
    init : function(_d) {
        // 调用init须传入数组
        var me = this,
            i = 0,
            data,
            len,
            tplHTML = "",
            css_value = "";
        
        if(evm.isUndefined(_d))
            throw Error("VListBox_v2 配置对象未找到data属性");
        
        me.config.data = _d;
        data = me.config.data;
        len = data.length;
        
        if(me.isBuilt) {
            me.list_page = 0;
            me.active_index = 0;
        }
        
        me.back_index = -1;
        me.back_page  =- 1;
        
        if(evm.isString(me.parent_node))
            me.parent_node = evm.$(me.parent_node);
        
        me.box_elem = evm.$(me.box_id);
        
        // 判断是否存在容器元素
        if(!me.box_elem)
            me.box_elem = evm.createElem("div", {
                                id: me.box_id,
                                className: me.class_name
                            }, me.parent_node || document.body);
        
        if(len > 0)
            // 数据非空,计算页码
            me.list_total_page = Math.ceil(len / me.max_list_num) - 1;
        
        if(!me.isBuilt) {
            // 动态生成节点
            me.isBuilt = !me.isBuilt;
            while(i<me.max_list_num) {
                css_value = "";
                css_value += "width:"+(me.list_width<=0?"100%;":me.list_width+"px;");
                if(me.list_height <= 0) {
                    css_value += "position:relative;min-height:40px;";
                }
                else{
                    css_value += "position:absolute;"+
                        "height:"+(me.list_height)+"px;"+
                        "line-height:"+(me.list_height)+"px;"+
                        "top:"+(i*(me.list_height+me.gap_y))+"px;"
                }
                
                css_value += "overflow:hidden;";
            
                tplHTML += "<div class=\""+me.class_name+"-list\" "+
                        "id=\""+me.class_name+"-list-"+i+"\" "+
                        "style=\""+css_value+"\"></div>";
                i+=1;
            };
            
            evm.html(me.box_elem, tplHTML);
            
            me.box_width = me.list_width + me.gap_x;
            me.box_height = me.max_list_num*(me.list_height+me.gap_y);
            
            css_value = {
                "width" : me.box_width + "px",
                "height" : me.box_height + "px",
                "position" : "absolute",
                "left" : me.start_x + "px",
                "top" : me.start_y + "px"
            };
            
            //设置box_elem样式
            if(evm.isString(me.config.style))
                evm.cssText(me.box_elem, me.config.style);
            
            evm.css(me.box_elem, css_value);
        }
        
        me.paint();
        
        return me;
    },
    paint: function() {
        var me = this,
            i = 0,
            j = 0,
            data = me.config.data,
            len = data.length,
            tplHTML = "",
            prop,
            hasPaintCallback = false,
            tplStore;
        
        if(evm.isFunction(me.config.paintCallback)) {
            hasPaintCallback = true;
            tplStore = [];
        }
        
        var start = me.list_page * me.max_list_num;
        
        for(i=0; i<me.max_list_num; i++) {
            
            if((start+i) < len) {
                j = 0;
                tplHTML = "";
                
                if(me.model.length > 0) {
                    
                    if(!data[start + i])
                        continue;
                    
                    while(j<me.model.length) {
                        if(me.model[j].text)
                            prop = data[start+i][me.model[j].text];
                        else
                            prop = data[start+i];
                        
                        if(me.model[j].callback && evm.isFunction(me.model[j].callback))
                            prop = me.model[j].callback.call(me,prop,i,data,me.model[j].text);
                        
                        tplHTML += prop;
                        j+=1;
                    };
                }else{
                    tplHTML = data[start + i];
                }
        
            }else{
                if((start + i) === 0)
                    // 第一个位置设置为空
                    tplHTML = me.emptyMsg;
                else
                    tplHTML = "";
            }
            if(hasPaintCallback)
                tplStore.push(tplHTML);
            else
                evm.html(evm.$(me.class_name+"-list-"+i),tplHTML);
            
        }
        if(hasPaintCallback)
            me.config.paintCallback(me.class_name+"-list-", tplStore);
            
        return me;
    },
    moveV: function(_d) {
        var me = this,
            length = me.config.data.length,
            size = me.max_list_num,
            ending = length % size,
            evt = null;
    
        me.back_page = me.list_page;
        me.back_index = me.active_index;
        
        // 自定义event对象
        evt = {
            type : "blur",
            dir : _d,
            index : me.active_index,
            back_index : me.back_index,
            sid : me.getIndex(),
            page : me.list_page,
            back_page : me.back_page,
            totalPage : me.list_total_page,
            size : me.max_list_num,
            data : me.getData()
        };
    
        me.onEvent(evt);
        me.onBlur(evt);
    
        if(_d == "DOWN") {
            if(me.list_page != me.list_total_page ){
                if(me.active_index != size - 1){
                    me.active_index += 1;
                }else{
                    me.active_index = 0;
                    me.list_page += 1;
                }
            }else{
                ending = (ending == 0 ? size : ending);
                if(me.active_index != ending - 1){
                    me.active_index += 1;
                }else{
                    me.active_index = 0;
                    me.list_page = 0;
                }
            }
        }else{
            if(me.list_page != 0 ){
                if(me.active_index != 0){
                    me.active_index -= 1;
                }else{
                    me.active_index =  size - 1;
                    me.list_page -= 1;
                }
            }else{
                if(ending == 0 ) ending = size;
                if(me.active_index != 0 ){
                    me.active_index -= 1;
                }else{
                    me.active_index = ending - 1;
                    me.list_page = me.list_total_page;
                }
            }
        }
    
        evt = {
            type : "focus",
            dir : _d,
            index : me.active_index,
            back_index : me.back_index,
            sid : me.getIndex(),
            page: me.list_page,
            back_page : me.back_page,
            totalPage : me.list_total_page,
            size : me.max_list_num,
            data : me.getData()
        };
            
        me.onEvent(evt);
        me.onFocus(evt);
        return me;
    },
    isEmpty: function() {
        return this.config.data.length === 0;
    },
    getChildIDByIndex: function(_n) {
        var me = this,
            childID = me.class_name + "-list-" + _n;
        return childID;
    },
    getData: function() {
        return this.config.data;
    },
    getIndex: function() {
        var me = this;
        return me.list_page * me.max_list_num + me.active_index;
    },
    getActiveIndex: function() {
        return this.active_index;
    },
    setIndex: function(_n) {
        var me = this;
        me.list_page = Math.floor( _n / this.max_list_num );
        me.active_index = _n % this.max_list_num;
        return me;
    },
    toggle: function(_d) {
        var me = this;
        evm.css( me.box_elem, {"display":(_d==="show"?"block":"none")} );
    }
});
