<?php

/**
 * 日志处理类
 * 主要复制打印机顶盒页面提交的日志
 *
 * @since alpha 0.0.1
 * @date 2014.03.04
 * @author
 *
 */
const LOG_FILE_PATH = '/web-logs/';
const LOG_SWITCH = true;

class Log
{

    //单例模式
    private static $instance = NULL;
    //文件句柄
    private static $handle = NULL;
    //日志开关
    private $log_switch = NULL;
    //日志相对目录
    private $log_file_path = NULL;
    //日志文件前缀，stb_page_
    private $log_file_pre = 'stb-page-';

    /**
     * 构造函数
     *
     * @since alpha 0.0.1
     * @date 2014.02.04
     */
    protected function __construct()
    {

        $this->log_file_path = $_SERVER['DOCUMENT_ROOT'].'/web-logs/';

        $this->log_switch = LOG_SWITCH;

    }

    /**
     * 单例模式
     *
     * @since alpha 0.0.1
     * @date 2014.02.04
     */
    public static function get_instance()
    {
        if (!self::$instance instanceof self) {
            self::$instance = new self;
        }
        return self::$instance;
    }

    /**
     *
     * 日志记录
     *
     * @param string $time 时间
     * @param string $type debug info warn error
     * @param string $desc
     *
     * @since alpha 0.0.1
     * @date 2014.02.04
     *
     */
    public function log($time, $type, $desc)
    {
        if ($this->log_switch) {

            if (self::$handle == NULL) {
                $filename = $this->log_file_pre . date('Y-m-d') . '.log';
                self::$handle = fopen($this->log_file_path . $filename, 'a');
            }

            fwrite(self::$handle, "[$time] ".strtoupper($type) . ' LOG:' . ' ' . $desc);

        }
    }

    /**
     * 关闭文件句柄
     *
     * @since alpha 0.0.1
     * @date 2014.02.04
     * @author genialx
     */
    public function close()
    {
        fclose(self::$handle);
    }
}

$logger = Log::get_instance();

header("Content-type: text/html; charset=utf-8");

$input = urldecode($_POST['log']);
if (get_magic_quotes_gpc())//如果get_magic_quotes_gpc()是打开的
{
    $input = stripslashes($input);//将字符串进行处理
}

//处理$input
$inputArr = explode('*', $input);
foreach ($inputArr as $item) {
    if (preg_match('/\[(debug|info|warn|error)\]\[(.*)\]/U', $item, $matches) != 0) {
        $all = $matches[0];
        $type = $matches[1];
        $time = $matches[2];

        $logger->log($time,$type,str_replace($all,'',$item),1);
    }
    else{
        $logger->log(str_replace("\n",'',$item),'info',"\n");
    }
}

$logger->close();

echo "{\"success\":1}";
