/**
 * 文字自动上下滑动显示
 * 返回类Slide的实例
 * 依赖/swatapps/ape/evm.js
 * 创建时间：2016-04-13
 * 版本：v1.0
 */
(function(window){
	function Slide(options){
		//默认配置
		var defaults = {
			//滑动块容器元素的id
			boxId:'',
			boxLeft:0,
			boxTop:0,
			//单行宽度
			lineWidth:0,
			//单行高度
			lineHeight:0,
			//滑动时间间隔，s
			intervalTime:5,
			//传入滑动文字的数组
			data:null,
			//滑动动画时间
			duration:'500ms'
		};
		evm.extend(this,defaults,options);

		//滑动块容器元素对象
		this._boxElm = null;
		//滑动块元素对象
		this._innerElm = null;
		//滑动步长
		this._step = this.lineHeight;
		//滑动块元素高度
		this._innerHeight = 0;
		this._intervalId = null;
		this._startId = null;

		this.init();
	}
	evm.extend(Slide.prototype,{
		_buldView:function(){
			this._boxElm = evm.$(this.boxId);
			if(!this._boxElm){
				evm.createElem('div',{
					className:'ape-slide'
				});
			}
			evm.css(this._boxElm,'position:absolute;left:'+this.boxLeft+'px;top:'+this.boxTop+'px;width:'+this.lineWidth+'px;height:'+this.lineHeight+'px;line-height:'+ this.lineHeight +'px;overflow:hidden;');

			this._innerElm = evm.createElem('ul',{
				className:'ape-slide-inner',
				style:'position:relative;top:0;'
			},this._boxElm);

			var html = '';
			for(var index in this.data){
				html += '<li style="width:'+ this.lineWidth +'px;">'+ this.data[index] +'</li>';
			}
			evm.html(this._innerElm,html);
		},
		_calculateInnerHeight:function(){
			var self = this;
			setTimeout(function(){
				self._intervalId = setInterval(function(){
					if(self._innerHeight > 0){
						clearInterval(self._intervalId);
						self.start();
					}
					self._innerHeight = parseFloat(evm.getStyle(self._innerElm,'height') || self._innerElm.clientHeight);
				},10);
			},1000);
		},
		init:function(){
			this._buldView();
			this._calculateInnerHeight();
		},
		start:function(){
			var self = this;
			if(self._innerHeight > 0){
				self._startId = setInterval(function(){
					var top = parseFloat(evm.getStyle(self._innerElm,'top'));
					if(top > -(self._innerHeight - self._step)){
						evm.css(self._innerElm,{
							webkitTransitionDuration:self.duration
						});
						top -= self._step;
					}
					else{
						evm.css(self._innerElm,{
							webkitTransitionDuration:'0ms'
						});
						top = 0;
					}
					evm.css(self._innerElm,{
						top : top+'px'
					});
				},self.intervalTime*1000);
			}
		},
		stop:function(){
			clearInterval(this._startId);
		}
	});

	evm.namespace('evm.util.slide');
	evm.util.slide = function(options){
		return new Slide(options);
	}
})(this);