/**
 * @file 基础js，包含对原生对象的扩展和evm.js的扩展
 * @import /swatapps/ape/evm.js /swatapps/ape/util-keymap.js
 * @createTime:2015-10-28
 *
 * Ipanel 3.0不支持in操作符----------2015-11-24
 */
/**************************************************************************************
 *                                 对原生对象的扩展
/**************************************************************************************/
// 日期格式化
// @F: 日期时间格式
Date.prototype.format = function( F )
{
    F = F || 'YYYY-mm-dd HH:ii:ss';
    var o =
    {
        'm+' :  this.getMonth() + 1	//月
        ,'d+' : this.getDate()		//日
        ,'H+' : this.getHours()		//时
        ,'i+' : this.getMinutes()	//分
        ,'s+' : this.getSeconds()	//秒
        ,'q+' : Math.floor((this.getMonth() + 3) / 3)	//季
        ,'S+' : this.getMilliseconds()	//毫秒
        ,'w+' : ['0', '1', '2', '3', '4', '5', '6'][this.getDay()]
        ,'W+' : ['日', '一', '二', '三', '四', '五', '六'][this.getDay()]
    }

    if( /(Y+)/.test( F )) F = F.replace( RegExp.$1, ( this.getFullYear() + '' ).substr( 4 - RegExp.$1.length ));
    for( var K in o )
    {
        if( new RegExp( '(' + K + ')' ).test( F ))
            F = F.replace( RegExp.$1
                ,( RegExp.$1.length == 1 ) ? ( o[K] ) : ( (( K == 'S+' ? '000' : '00' ) + o[K]).substr(('' + o[K]).length)) );
    }
    return F;
};
if(!Array.prototype.filter){
    Array.prototype.filter = function(fun/*, thisArg*/){
        if (this === void 0 || this === null) {
            throw new TypeError();
        }

        var t = Object(this);
        var len = t.length >>> 0;
        if (typeof fun !== 'function') {
            throw new TypeError();
        }

        var res = [];
        var thisArg = arguments.length >= 2 ? arguments[1] : void 0;
        for (var i = 0; i < len; i++) {
            /*if (i in t) {*/
                var val = t[i];

                // NOTE: Technically this should Object.defineProperty at
                //       the next index, as push can be affected by
                //       properties on Object.prototype and Array.prototype.
                //       But that method's new, and collisions should be
                //       rare, so use the more-compatible alternative.
                if (fun.call(thisArg, val, i, t)) {
                    res.push(val);
                }
            /*}*/
        }

        return res;
    }
}
if(!Array.prototype.forEach){
    Array.prototype.forEach = function(callback,thisArg){
        var T, k;
        if (this == null) {
            throw new TypeError(' this is null or not defined');
        }
        // 1. Let O be the result of calling ToObject passing the |this| value as the argument.
        //var O = Object(this);//Ipanel 3.0不支持此操作
        var O = this;
        // 2. Let lenValue be the result of calling the Get internal method of O with the argument "length".
        // 3. Let len be ToUint32(lenValue).
        var len = O.length >>> 0;

        // 4. If IsCallable(callback) is false, throw a TypeError exception.
        // See: http://es5.github.com/#x9.11
        if (typeof callback !== "function") {
            throw new TypeError(callback + ' is not a function');
        }
        // 5. If thisArg was supplied, let T be thisArg; else let T be undefined.
        if (arguments.length > 1) {
            T = thisArg;
        }
        // 6. Let k be 0
        k = 0;
        // 7. Repeat, while k < len
        while (k < len) {
            var kValue;

            // a. Let Pk be ToString(k).
            //   This is implicit for LHS operands of the in operator
            // b. Let kPresent be the result of calling the HasProperty internal method of O with argument Pk.
            //   This step can be combined with c
            // c. If kPresent is true, then
            /*if (k in O) {*/

                // i. Let kValue be the result of calling the Get internal method of O with argument Pk.
                kValue = O[k];

                // ii. Call the Call internal method of callback with T as the this value and
                // argument list containing kValue, k, and O.
                callback.call(T, kValue, k, O);
            /*}*/
            // d. Increase k by 1.
            k++;
        }
        // 8. return undefined
    };
}

/**************************************************************************************
 *                                 类的帮助函数
 /**************************************************************************************/
function extend(subClass,superClass){
    var F = function(){};
    F.prototype = superClass.prototype;
    subClass.prototype = new F;
    subClass.prototype.constructor = subClass;

    subClass.superClass = superClass.prototype;
    if(superClass.prototype.constructor == Object){
        superClass.prototype.constructor = superClass;
    }
}

(function(window,undefined){
	var o2str = Object.prototype.toString;

    //处理Json
    /*var JSON = {
        parse:function(val){
            if(typeof val === 'string'){
                val = eval('('+val+')');
            }
            return val;
        }
    };
    window.JSON = JSON;*/

    var evm = window.evm || {};
    evm.extend(evm,{
        //计算尺寸或者位置
        getElementPosition:function(e){
            var x = 0, y = 0;
            while (e != null) {
                x += e.offsetLeft;
                y += e.offsetTop;
                e = e.offsetParent;
            }
            return { x: x, y: y };
        },
        //DOM操作
        $:function(val){
            if(typeof val === 'string'){
                val = document.getElementById(val);
            }
            return val;
        },
        getElementsByClassName:function(className,tag,parent){
            parent = parent || document;
            if(!(parent = evm.$(parent))) return false;

            var allTags = parent.all && tag === '*' ? parent.all : parent.getElementsByTagName(tag);

            className = className.replace(/\-/g,'\\-');
            var reg = new RegExp('(^|\\s+)'+ className +'(\\s+|$)');
            var matchingElements = [];
            for(var i = 0;i < allTags.length;i++){
                var node = allTags[i];
                if(reg.test(node.className)){
                    matchingElements.push(node);
                }
            }
            return matchingElements;
        },
        removeChildren:function(parent){
            if(!(parent = evm.$(parent))) return false;

            while(parent.firstChild){
                parent.removeChild(parent.firstChild);
            }
            return true;
        },
		html:function(elm,str){
			if(str == undefined){
				return elm.innerHTML;
			}

			elm.innerHTML = str;
		},
        text:function(elm,str){
            if(str == undefined){
                return elm.innerText;
            }

            if(elm.innerText){
                elm.innerText = str;
            }
            else{
                elm.appendChild(document.createTextNode(str));
            }
            return elm;
        },
        //事件处理
        addEvent:function(elm,type,fn){
            if(!(elm = evm.$(elm))) return;

            if(elm.addEventListener){
                elm.addEventListener(type,fn,false);
            }
            else if(elm.attachEvent){
                elm['e'+type+fn] = fn;
                elm[type+fn] = function(){
                    elm['e'+type+fn](window.event);
                }
                elm.attachEvent('on'+type,elm[type+fn]);
            }
			else{
				elm['on'+type] = fn;
			}
        },
        preventDefault:function(event){
            if(event.preventDefault){
                event.preventDefault();
            }
            else if(event.returnValue){
                event.returnValue = false;
            }
            else{
                return false;
            }
        },
        //工具方法
		// 全局标识
		addQueryString:function(/*url,name1,name2*/){
			var coreFunction,
				queryObj = evm.getUrl();

			coreFunction = function(){
				var url = arguments[0];
				if(!url){
					return '';
				}
				for(var i = 1;i < arguments.length;i++){
					var value = queryObj[arguments[i]];
					if(value){
						value = encodeURIComponent(value);
					}
					else{
						value = '';
					}
					if(url.indexOf('?') === -1){
						url = url + '?'+arguments[i]+'='+value;
					}else{
						url = url + '&'+arguments[i]+'='+value;
					}
				}
				return url;
			};

			evm.addQueryString = coreFunction;
			return coreFunction.apply(this,arguments);
		},
		__globalCounter: 0,
		// 取下一个全局唯一计数
		getNextGlobalId: function()
		{
			return this.__globalCounter;
		},
		// 生成指定前缀的全局唯一标识
		makeGlobalId: function( S )
		{
			S = S ? S : '';
			return S + ( this.__globalCounter++ ) + (Math.floor( Math.random() * 1000 ) + '');
		},
		isArray:function(val){
			o2str.call(val) === '[object Array]';
		},
		isUndefined:function(val){
			return typeof val === 'undefined';
		},
		isNumber:function(val){
			return typeof val === 'number';
		},
		isObject:function(val){
			return typeof val === 'object';
		},
		isString:function(val){
			return typeof val === 'string';
		},
		isFunction:function(val){
			return typeof val === 'function';
		},
        trim:function(str){
            return str.replace(/^\s+|\s+$/g,'');
        },
        cookie:function (name, value, options) {
            if (typeof value != 'undefined') { // name and value given, set cookie
                options = options || {};
                if (value === null) {
                    value = '';
                    options.expires = -1;
                }
                var expires = '';
                if (options.expires && (typeof options.expires == 'number' || options.expires.toUTCString)) {
                    var date;
                    if (typeof options.expires == 'number') {
                        date = new Date();
                        date.setTime(date.getTime() + (options.expires * 24 * 60 * 60 * 1000));
                    } else {
                        date = options.expires;
                    }
                    expires = '; expires=' + date.toUTCString(); // use expires attribute, max-age is not supported by IE
                }
                var path = options.path ? '; path=' + options.path : '';
                var domain = options.domain ? '; domain=' + options.domain : '';
                var secure = options.secure ? '; secure' : '';
                document.cookie = [name, '=', encodeURIComponent(value), expires, path, domain, secure].join('');
            } else { // only name given, get cookie
                var cookieValue = null;
                if (document.cookie && document.cookie != '') {
                    var cookies = document.cookie.split(';');
                    for (var i = 0; i < cookies.length; i++) {
                        var cookie = evm.trim(cookies[i]);
                        // Does this cookie string begin with the name we want?
                        if (cookie.substring(0, name.length + 1) == (name + '=')) {
                            cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                            break;
                        }
                    }
                }
                return cookieValue;
            }
        },
        getQueryString:function(key){
            var searchStr = window.location.search.substr(1);
            var reg = new RegExp(key+'=([^=&]*)');
            var value = '';
            if(reg.test(searchStr)){
                value = window.decodeURIComponent(searchStr.match(reg)[1]);
            }
            return value;
        },
		json:{
			parse:function(val){
				if(typeof val === 'string'){
					val = eval('('+val+')');
				}
				return val;
			},
			stringify:function(O){
				// 将对象转换为 Json 串
				// Key 不使用引号, 所以不能包含空格
				if( JSON && JSON.stringify ) return JSON.stringify( O );

				var S = '{', sEnd = '}';
				if( evm.isArray( O ))
				{
					S = '[';
					sEnd = ']';
				}

				for( var i in O )
				{
					S += i + ':';

					//if( I.isUndefined( O[i] )) S += 'undefined';
					if( evm.isUndefined( O[i] )) S += '""';
					else if( evm.isObject( O[i] )) S += evm.json.stringify( O[i] );
					else if( evm.isArray( O[i] )) S += evm.json.stringify( O[i] );
					else if( evm.isString( O[i] )) S += '"' + O[i] + '"';
					else S += O[i];

					S += ',';
				}

				S = S.substr(0, S.length-1);
				S += sEnd;

				return S;
			}
		}
    });
})(this);

/**************************************************************************************
 *                                 按键全局控制对象
 /**************************************************************************************/
var util_keymap = window.util_keymap || {};
util_keymap.stb = {};
function grabEvent(event,globalGrabEvent){
    var keyCode = event.keyCode || event.which;
    var alias = util_keymap.stb[keyCode] || util_keymap.pc[keyCode];

    if(alias == undefined){
        alias = 'undefined';
    }

	//可以传入优先处理函数
	//如果返回true不分发事件
	if(evm.isFunction(globalGrabEvent) && globalGrabEvent.call(this,alias)){
		return;
	}

    grabEvent.components.forEach(function(obj){
        obj.action(alias,event);
    });

    if(this.preventDefault){
        evm.preventDefault(event);
    }
}
evm.extend(grabEvent,{
    components:[],
	lastComponent:null,
    //是否阻止按键的默认事件
    preventDefault:0
});

//需要按键监听的对象的基类
function KeyListenBase(){

}
KeyListenBase.prototype = {
    addListener:function(){
        grabEvent.components.push(this);
        this.action();
    },
    removeListener:function(){
        var me = this;
        grabEvent.components = grabEvent.components.filter(function(obj){
            return me !== obj;
        });
    },
    flush:function(){
        grabEvent.components = [];
    },
	setLastComponent:function(){
		grabEvent.lastComponent = this;
	},
	getLastComponent:function(){
		return grabEvent.lastComponent;
	}
};
/**************************************************************************************
 *                                 页面元素键值处理包装类
 /**************************************************************************************/
function ElementsWrapperForKey(options){
    this._activeIndex = 0;
    this._ids = options.ids;
    //元素响应按键方向
    //H水平 V上下 ALL全部
    this._moveDir = options.moveDir || 'H';
    //配置方法
    this.onFocus = options.onFocus;
    this.onBlur = options.onBlur;

    this.onWidgetBlur = options.onWidgetBlur || function(){};
    this.doSelect = options.doSelect || function(){};

    this.init();
}
extend(ElementsWrapperForKey,KeyListenBase);
evm.extend(ElementsWrapperForKey.prototype,{
    action:function(alias,event){
        switch(alias){
            case 'UP':
            case 'RIGHT':
            case 'DOWN':
            case 'LEFT':
                this._move(alias);
                break;
            case 'SELECT':
                this.doSelect(this._ids[this._activeIndex],alias,event);
                break;
            case undefined:
                this._onFocus();
                break;
        }
    },
	getActiveElement:function(){
		var id = this._ids[this._activeIndex];
		return evm.$(id);
	},
    getIds:function(){
        return this._ids;
    },
    init:function(){
        //生成高亮背景

    },
    setActiveIndex:function(nIndex){
        this._activeIndex = Math.max(0,Math.min(nIndex,this._ids.length));
    },
    getActiveIndex:function(){
        return this._activeIndex;
    },
    _move:function(alias){
        var len = this._ids.length;
        var step = 1;
        var moveDir = this._moveDir;

        if(moveDir === 'V'){
            if(alias === 'UP') step = -1;
            if(alias === 'DOWN') step = 1;
            if(alias === 'LEFT' || alias === 'RIGHT') step = 0;
        }
        else if(moveDir === 'ALL'){
            if(alias === 'UP' || alias === 'LEFT') step = -1;
            if(alias === 'DOWN' || alias === 'RIGHT') step = 1;
        }
        else/*H*/{
            if(alias === 'LEFT') step = -1;
            if(alias === 'RIGHT') step = 1;
            if(alias === 'UP' || alias === 'DOWN') step = 0;
        }

        if(step === 0){
            this._onBlur();
            this.onWidgetBlur(alias);
            return;
        }

        var ai = this._activeIndex;
        ai += step;
        if(ai >= 0 && ai < len){
            this._onBlur();
            this._activeIndex = ai;
            this._onFocus();
        }
        else{
            this._onBlur();
            this.onWidgetBlur(alias);
        }
    },
    _onFocus:function(){
        var id = this._ids[this._activeIndex];
        var elm = evm.$(id);
        evm.addClass(elm,'focus');

        this._trigger('onFocus',[this._activeIndex]);
    },
    _onBlur:function(){
        var id = this._ids[this._activeIndex];
        var elm = evm.$(id);
        evm.removeClass(elm,'focus');

        this._trigger('onBlur',[this._activeIndex]);
    },
    _trigger:function(eventName,args){
        if(typeof this[eventName] === 'function'){
            this[eventName].apply(this,args);
        }
    }
});