/**
 *  @file hButtonList
 *  @des 按钮组DOM直接页面定义好
 *  @import /swatapps/ape/evm.js
 */

function HButtonList(options){
    this._activeIndex = 0;
    this._ids = options.ids || [];
    if(this._ids.length === 0){
        throw new Error('按钮组ids未配置');
    }

    this.onWidgetBlur = options.onWidgetBlur || function(){};
    this.doSelect = options.doSelect || function(){};
}
HButtonList.prototype = {
    action:function(dir){
        switch(dir){
            case 'UP':
                this._moveV(-1,dir);
                break;
            case 'RIGHT':
                this._moveH(1,dir);
                break;
            case 'DOWN':
                this._moveV(1,dir);
                break;
            case 'LEFT':
                this._moveH(-1,dir);
                break;
            case 'SELECT':
                this._doSelect();
                break;
            default:
                this._onFocus();
                break;
        }
    },
    init:function(){

    },
    _moveH:function(nStep,dir){
        var ai = this._activeIndex;
        ai += nStep;
        if(ai >= 0 && ai < this._ids.length){
            this._onBlur();
            this._activeIndex = ai;
            this._onFocus();
        }
        else{
            this._onBlur();
            this.onWidgetBlur(dir);
        }
    },
    _moveV:function(nStep,dir){
        this._onBlur();
        this.onWidgetBlur(dir);
    },
    _onFocus:function(){
        var elm = document.getElementById(this._ids[this._activeIndex]);
        elm && evm.addClass(elm,'focus');
    },
    _onBlur:function(){
        var elm = document.getElementById(this._ids[this._activeIndex]);
        elm && evm.removeClass(elm,'focus');
    },
    _doSelect:function(){
        this.doSelect(this._activeIndex);
    }
};